/* A Bison parser, made from /home/users/yusuke/tmp/ll/src/yacc.yy
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	TOK_ATOM	257
# define	TOK_FEAT	258
# define	TOK_VAR	259
# define	TOK_STARTP	260
# define	TOK_MODULENAME	261
# define	TOK_INTEGER	262
# define	TOK_STRING	263
# define	TOK_DOUBLE	264
# define	TOK_INVALID	265
# define	TOK_IS	266
# define	TOK_MOD	267
# define	TOK_EOF	268
# define	SUBSUMED_BY	269
# define	ATTR_DEF	270
# define	ATOMP	271
# define	LISTEND	272
# define	MEANS	273
# define	MACRO_DEF	274
# define	QUERY	275
# define	UMEANS	276
# define	IF_THEN	277
# define	NOT	278
# define	CMP_L	279
# define	CMP_LE	280
# define	CMP_G	281
# define	CMP_GE	282
# define	CMP_EQ	283
# define	CMP_NE	284
# define	NOT_UNIFIABLE	285
# define	BIT_OR	286
# define	BIT_AND	287
# define	INTDIV	288
# define	USIGN	289
# define	FEATURE	290

#line 1 "yacc.yy"

/* $Id: yacc.yy,v 1.15 2005/02/12 04:11:38 yusuke Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

static const char rcsid[] = "$Id: yacc.yy,v 1.15 2005/02/12 04:11:38 yusuke Exp $";
	
#define IN_BISON_FILE

#include "lconfig.h"
#include "structur.h"
#include "machine.h"
#include "builtin.h"
#include "proc.h"
#include "parse.h"
#include "lilfes.h"

#include <iostream>
#include <sstream>
#include <malloc.h>
#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#endif
#include <setjmp.h>

namespace lilfes {

extern int codeoutflag;
static core_p save;

void yyerr(machine *m, char* s);
#define YYERROR_VERBOSE
#define yyerror(X) yyerr(PARM->mach,(X))

#define progalter 0

#define ERRBUF 100
#define YYMAXDEPTH  250000
#define YYINITDEPTH 70000
// Avoid bison bug for C++ output
#define YYSTACK_USE_ALLOCA 0
#define __attribute__(X) 

//#define DEBUG
// #define YYDEBUG 1
#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm
#define PARM ((parser_control *)parm)
bool compiled = false;
bool errored = false;

bool warn_old_feature_notation = false;

#if defined(PROFILE)
static prof *profx;
#endif	/* defined(PROFILE) */

FSP prog_types;
FSP prog_list;
FSP prog_list_top;
FSP prog_vars;
FSP prog_vars_top;

static lstring progalter_fprefix = "__";
static lstring progalter_tprefix = "__";

void CheckSingleton(machine *m,const char *where);

int yyparse();

//std::istream *input_stream = NULL;
//std::ostream *output_stream = NULL;
//std::ostream *error_stream = NULL;
std::istream *input_stream = &std::cin;
std::ostream *output_stream = &std::cout;
std::ostream *error_stream = &std::cerr;
bool constraint_status = true;

void change_modulename(char *);
char *my_malloc(int);
char *my_strdup(char *);

void hook()
{

}


bool bi_feature(char *s)
{
	if( strcmp(s, "hd") == 0 )	return true;
	if( strcmp(s, "tl") == 0 )	return true;
	if( strcmp(s, "chead") == 0 )	return true;
	if( strcmp(s, "cbody") == 0 )	return true;
	if( strcmp(s, "arg1") == 0 )	return true;
	if( strcmp(s, "arg2") == 0 )	return true;
	if( strcmp(s, "arg3") == 0 )	return true;
	if( strcmp(s, "arg4") == 0 )	return true;
	if( strcmp(s, "arg5") == 0 )	return true;
	if( strcmp(s, "arg6") == 0 )	return true;
	if( strcmp(s, "arg7") == 0 )	return true;
	if( strcmp(s, "arg8") == 0 )	return true;
	if( strcmp(s, "arg9") == 0 )	return true;
	if( strcmp(s, "arg10") == 0 )	return true;
	if( strcmp(s, "arg11") == 0 )	return true;
	if( strcmp(s, "arg12") == 0 )	return true;
	if( strcmp(s, "arg13") == 0 )	return true;
	if( strcmp(s, "arg14") == 0 )	return true;
	if( strcmp(s, "arg15") == 0 )	return true;
	return false;
}

bool bi_type(char *s)
{
	if( strcmp(s, "bot") == 0 )	return true;
	if( strcmp(s, "integer") == 0 )	return true;
	if( strcmp(s, "string") == 0 )	return true;
	if( strcmp(s, "float") == 0 )	return true;
	if( strcmp(s, "feature") == 0 )	return true;
	if( strcmp(s, "list") == 0 )	return true;
	if( strcmp(s, "cons") == 0 )	return true;
	if( strcmp(s, "nil") == 0 )	return true;
	if( strcmp(s, "true") == 0 )	return true;
	if( strcmp(s, "fail") == 0 )	return true;
	if( strcmp(s, "is") == 0 )	return true;
	if( strcmp(s, "type_attr") == 0 )	return true;
	if( strcmp(s, "final") == 0 )	return true;
	if( strcmp(s, "extendable") == 0 )	return true;
	if( strcmp(s, "pred") == 0 )	return true;
	if( strcmp(s, "pred/1") == 0 )	return true;
	if( strcmp(s, "pred/2") == 0 )	return true;
	if( strcmp(s, "pred/3") == 0 )	return true;
	if( strcmp(s, "pred/4") == 0 )	return true;
	if( strcmp(s, "pred/5") == 0 )	return true;
	if( strcmp(s, "pred/6") == 0 )	return true;
	if( strcmp(s, "pred/7") == 0 )	return true;
	if( strcmp(s, "pred/8") == 0 )	return true;
	if( strcmp(s, "pred/9") == 0 )	return true;
	if( strcmp(s, "pred/10") == 0 )	return true;
	if( strcmp(s, "pred/11") == 0 )	return true;
	if( strcmp(s, "pred/12") == 0 )	return true;
	if( strcmp(s, "pred/13") == 0 )	return true;
	if( strcmp(s, "pred/14") == 0 )	return true;
	if( strcmp(s, "pred/15") == 0 )	return true;
	if( strcmp(s, "<") == 0 )	return true;
	if( strcmp(s, "<=") == 0 )	return true;
	if( strcmp(s, ">") == 0 )	return true;
	if( strcmp(s, ">=") == 0 )	return true;
	if( strcmp(s, "=") == 0 )	return true;
	if( strcmp(s, "=\\=") == 0 )	return true;
	if( strcmp(s, "=:=") == 0 )	return true;
	if( strcmp(s, ":-") == 0 )	return true;
	if( strcmp(s, ":-/1") == 0 )	return true;
	if( strcmp(s, ":-/2") == 0 )	return true;
	if( strcmp(s, "?-") == 0 )	return true;
	if( strcmp(s, ",") == 0 )	return true;
	if( strcmp(s, ";") == 0 )	return true;
	if( strcmp(s, "+") == 0 )	return true;
	if( strcmp(s, "-") == 0 )	return true;
	if( strcmp(s, "*") == 0 )	return true;
	if( strcmp(s, "/") == 0 )	return true;
	if( strcmp(s, "//") == 0 )	return true;
	if( strcmp(s, "mod") == 0 )	return true;
	if( strcmp(s, "^") == 0 )	return true;
	if( strcmp(s, "\\/") == 0 )	return true;
	if( strcmp(s, "/\\") == 0 )	return true;
	if( strcmp(s, "#") == 0 )	return true;
	if( strcmp(s, "\\+") == 0 )	return true;
	if( strcmp(s, "\\=") == 0 )	return true;
	return false;
}

} // namespace lilfes


#line 183 "yacc.yy"
#ifndef YYSTYPE
typedef union {
  int      ival;
  double   dval;
  char*    str;
  lilfes::type*    typeval;
  const lilfes::type *ctypeval;
  lilfes::feature* featval;
  const lilfes::feature* cfeatval;
  lilfes::module *modval;
  struct {
	  lilfes::feature *feat;
	  const lilfes::type *app;
  } appfeatval;
  lilfes::core_p   pval;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#line 275 "yacc.yy"


#include "in.h"

namespace lilfes {

HashTable<parsevar> vars;

int yylex(YYSTYPE *yylvalp, void *parm);

#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		236
#define	YYFLAG		-32768
#define	YYNTBASE	54

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 85)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    36,     2,     2,    46,     2,
      51,    52,    41,    39,    25,    40,    48,    42,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    23,
       2,    33,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,    38,    49,    45,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    53,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    24,    26,    27,
      28,    29,    30,    31,    32,    34,    35,    37,    43,    44,
      47
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     7,    10,    11,    16,    18,    20,
      23,    27,    30,    34,    37,    40,    44,    48,    52,    56,
      60,    65,    70,    76,    80,    84,    89,    93,    94,    96,
      97,    99,   100,   102,   104,   106,   108,   110,   113,   115,
     118,   119,   121,   126,   133,   142,   149,   151,   154,   157,
     159,   161,   165,   169,   171,   173,   175,   177,   181,   183,
     185,   189,   193,   197,   201,   205,   209,   213,   217,   220,
     224,   228,   231,   234,   238,   242,   246,   249,   252,   255,
     259,   263,   267,   271,   275,   279,   283,   287,   291,   293,
     295,   299,   303,   307,   311,   315,   319,   323,   327,   330,
     334,   338,   341,   344,   348,   352,   356,   359,   362,   365,
     369,   373,   377,   381,   385,   389,   393,   397,   401,   405,
     409,   413,   415,   419,   420,   422,   424,   428,   432,   434,
     436,   438,   440,   442,   444,   446,   448,   450,   452,   454,
     456,   458,   461,   463
};
static const short yyrhs[] =
{
      -1,    54,    14,     0,    54,    57,     0,    54,    71,     0,
       0,    54,     1,    55,    56,     0,    48,     0,    14,     0,
      61,    56,     0,    61,    49,    56,     0,    60,    56,     0,
      60,    49,    56,     0,    58,    56,     0,    59,    74,     0,
      61,    49,    16,     0,    60,    49,    16,     0,    61,    49,
      42,     0,    60,    49,    42,     0,    61,    39,    69,     0,
      61,    49,    39,    69,     0,    61,    39,    50,    69,     0,
      61,    49,    39,    50,    69,     0,    60,    25,    69,     0,
      70,    15,    81,     0,    70,    15,    50,    81,     0,    61,
      25,    81,     0,     0,    81,     0,     0,    33,     0,     0,
      36,     0,     3,     0,    12,     0,    13,     0,    65,     0,
      84,    65,     0,     4,     0,    84,     4,     0,     0,    84,
       0,    68,     4,    63,    62,     0,    68,     4,    63,    62,
      36,     8,     0,    68,     4,    63,    62,    64,    51,     8,
      52,     0,    68,     4,    63,     6,     8,    52,     0,     3,
       0,    76,    56,     0,    67,    74,     0,     5,     0,    81,
       0,    83,    78,    52,     0,    50,    79,    49,     0,     8,
       0,    10,     0,     9,     0,    72,     0,    51,    76,    52,
       0,    73,     0,    75,     0,    74,    39,    74,     0,    74,
      40,    74,     0,    74,    45,    74,     0,    74,    41,    74,
       0,    74,    42,    74,     0,    74,    37,    74,     0,    74,
      35,    74,     0,    74,    36,    74,     0,    38,    74,     0,
      74,    33,    74,     0,    74,    34,    74,     0,    39,    74,
       0,    40,    74,     0,    74,    46,    74,     0,    74,    19,
      74,     0,    74,    20,    74,     0,    19,    74,     0,    21,
      74,     0,    26,    74,     0,    74,    12,    74,     0,    74,
      13,    74,     0,    74,    43,    74,     0,    74,    27,    74,
       0,    74,    28,    74,     0,    74,    29,    74,     0,    74,
      30,    74,     0,    74,    31,    74,     0,    74,    32,    74,
       0,    73,     0,    77,     0,    76,    39,    76,     0,    76,
      40,    76,     0,    76,    45,    76,     0,    76,    41,    76,
       0,    76,    42,    76,     0,    76,    37,    76,     0,    76,
      35,    76,     0,    76,    36,    76,     0,    38,    76,     0,
      76,    33,    76,     0,    76,    34,    76,     0,    39,    76,
       0,    40,    76,     0,    76,    46,    76,     0,    76,    19,
      76,     0,    76,    20,    76,     0,    19,    76,     0,    21,
      76,     0,    26,    74,     0,    76,    25,    76,     0,    76,
      23,    76,     0,    76,    24,    76,     0,    76,    12,    76,
       0,    76,    13,    76,     0,    76,    43,    76,     0,    76,
      27,    76,     0,    76,    28,    76,     0,    76,    29,    76,
       0,    76,    30,    76,     0,    76,    31,    76,     0,    76,
      32,    76,     0,    74,     0,    78,    25,    74,     0,     0,
      80,     0,    74,     0,    74,    53,    74,     0,    74,    25,
      80,     0,    39,     0,    40,     0,    41,     0,    42,     0,
      33,     0,    45,     0,    20,     0,    19,     0,    21,     0,
      82,     0,    67,     0,    66,     0,     6,     0,    84,     6,
       0,     7,     0,     7,    84,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   289,   290,   291,   292,   293,   293,   299,   301,   303,
     305,   306,   307,   308,   311,   314,   316,   317,   318,   321,
     323,   324,   325,   326,   329,   331,   332,   335,   337,   340,
     342,   344,   346,   348,   349,   349,   351,   382,   405,   419,
     443,   445,   447,   462,   475,   488,   529,   550,   849,   867,
     884,   892,   967,   971,   976,   981,   988,   989,   995,   996,
     998,  1005,  1012,  1019,  1026,  1033,  1040,  1047,  1054,  1060,
    1067,  1074,  1080,  1086,  1103,  1110,  1117,  1123,  1130,  1136,
    1143,  1150,  1157,  1164,  1171,  1178,  1185,  1192,  1201,  1202,
    1203,  1211,  1218,  1225,  1232,  1239,  1246,  1253,  1260,  1266,
    1273,  1280,  1286,  1292,  1309,  1316,  1323,  1329,  1335,  1341,
    1351,  1361,  1371,  1378,  1385,  1392,  1399,  1406,  1413,  1420,
    1427,  1436,  1443,  1468,  1471,  1475,  1486,  1503,  1517,  1519,
    1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1531,
    1535,  1574,  1620,  1622
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "TOK_ATOM", "TOK_FEAT", "TOK_VAR", 
  "TOK_STARTP", "TOK_MODULENAME", "TOK_INTEGER", "TOK_STRING", 
  "TOK_DOUBLE", "TOK_INVALID", "TOK_IS", "TOK_MOD", "TOK_EOF", 
  "SUBSUMED_BY", "ATTR_DEF", "ATOMP", "LISTEND", "MEANS", "MACRO_DEF", 
  "QUERY", "UMEANS", "';'", "IF_THEN", "','", "NOT", "CMP_L", "CMP_LE", 
  "CMP_G", "CMP_GE", "CMP_EQ", "CMP_NE", "'='", "NOT_UNIFIABLE", "BIT_OR", 
  "'#'", "BIT_AND", "'\\\\'", "'+'", "'-'", "'*'", "'/'", "INTDIV", 
  "USIGN", "'^'", "'&'", "FEATURE", "'.'", "']'", "'['", "'('", "')'", 
  "'|'", "top", "@1", "period", "typedef", "flagsdef", "flagsdefx", 
  "introdef", "subsumedef", "apptype", "optional_equal", "optional_sharp", 
  "atom_or_atomop", "atom_with_module", "feature_with_module", 
  "optional_module_qualifier", "newfeat", "newtype", "command", "x_desc", 
  "desc", "i_desc", "ix_desc", "c_desc", "cx_desc", "arglist", "lists", 
  "nelistp", "atom", "atomtok", "startp", "modulename", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    54,    54,    54,    54,    55,    54,    56,    56,    57,
      57,    57,    57,    57,    58,    59,    59,    59,    59,    60,
      60,    60,    60,    60,    61,    61,    61,    62,    62,    63,
      63,    64,    64,    65,    65,    65,    66,    66,    67,    67,
      68,    68,    69,    69,    69,    69,    70,    71,    72,    72,
      72,    72,    72,    72,    72,    72,    73,    73,    74,    74,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    76,    76,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    78,    78,    79,    79,    80,    80,    80,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    82,
      83,    83,    84,    84
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     2,     2,     0,     4,     1,     1,     2,
       3,     2,     3,     2,     2,     3,     3,     3,     3,     3,
       4,     4,     5,     3,     3,     4,     3,     0,     1,     0,
       1,     0,     1,     1,     1,     1,     1,     2,     1,     2,
       0,     1,     4,     6,     8,     6,     1,     2,     2,     1,
       1,     3,     3,     1,     1,     1,     1,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     2,     2,     3,     3,     3,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     2,     2,     3,     3,     3,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     3,     0,     1,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     0,     5,    33,    38,    49,   140,   142,    53,    55,
      54,    34,    35,     2,   135,   134,   136,     0,   132,     0,
     128,   129,   130,   131,   133,   123,     0,     3,     0,     0,
       0,     0,    36,   139,   138,     0,     4,    56,    88,     0,
      89,    50,   137,     0,     0,     0,   143,    33,   106,   107,
     135,   136,     0,     0,   128,   129,    58,   108,    59,    98,
     101,   102,   125,     0,   124,     0,     8,     7,    13,    14,
      40,     0,    11,     0,    40,     0,     9,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,   121,     0,    39,   141,    37,
       6,    76,    77,    78,    68,    71,    72,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    52,    57,     0,    23,    41,    16,    18,    12,   135,
     136,   128,   129,   138,    26,     0,    40,    19,    15,    40,
      17,    10,     0,    24,   112,   113,   104,   105,   110,   111,
     109,   115,   116,   117,   118,   119,   120,    99,   100,    96,
      97,    95,    90,    91,    93,    94,   114,    92,   103,     0,
      51,    79,    80,    74,    75,    82,    83,    84,    85,    86,
      87,    69,    70,    66,    67,    65,    60,    61,    63,    64,
      81,    62,    73,   127,   126,    29,    21,    40,    20,    25,
     122,    30,    27,    22,     0,    42,    28,     0,    32,     0,
      45,    43,     0,     0,    44,     0,     0
};

static const short yydefgoto[] =
{
       1,    45,    68,    27,    28,    29,    30,    31,   225,   222,
     229,    32,    33,    34,   143,   144,    35,    36,    37,    56,
      62,    58,    39,    40,   106,    63,    64,    41,    42,    43,
      44
};

static const short yypact[] =
{
  -32768,   269,-32768,     0,-32768,-32768,-32768,     1,-32768,-32768,
  -32768,-32768,-32768,-32768,    39,-32768,    39,   318,-32768,    39,
      39,    39,-32768,-32768,-32768,   318,    39,-32768,    -8,   318,
       7,   119,-32768,-32768,   318,     9,-32768,-32768,-32768,   503,
  -32768,-32768,-32768,   318,    70,    -8,-32768,-32768,   575,   575,
     318,   318,   318,   318,   318,   318,-32768,   715,-32768,   258,
     -23,   -23,   433,   -30,-32768,   468,-32768,-32768,-32768,   610,
       1,    84,-32768,   409,     3,   164,-32768,-32768,   358,    39,
      39,    39,    39,    39,    39,    39,    39,    39,    39,    39,
      39,    39,    39,    39,    39,    39,    39,    39,    39,    39,
      39,    39,    39,    39,-32768,   610,   -22,-32768,-32768,-32768,
  -32768,   715,   715,   715,   341,   -17,   -17,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     318,-32768,-32768,    22,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,   124,     1,-32768,-32768,     4,
  -32768,-32768,   409,-32768,   762,   -23,   540,   540,   575,   645,
     680,   159,   159,   159,   159,   159,   159,   762,   762,   622,
     622,   258,   300,   300,    49,    49,   -23,   -13,-32768,   318,
  -32768,   797,   -17,   610,   610,   750,   750,   750,   750,   750,
     750,   797,   797,   658,   658,   341,   548,   548,   272,   272,
     -17,    -5,-32768,-32768,   610,    17,-32768,     1,-32768,-32768,
     610,-32768,   398,-32768,    56,   -31,-32768,    16,    61,    19,
  -32768,-32768,    67,    33,-32768,    86,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   -14,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   -32,-32768,   -71,-32768,   -60,-32768,-32768,-32768,   140,
     -16,-32768,   165,-32768,-32768,-32768,   -52,   -69,-32768,-32768,
      -7
};


#define	YYLAST		843


static const short yytable[] =
{
      46,    57,   153,   189,   154,   228,    66,   153,     7,   163,
       7,     7,   109,    69,   157,   -46,    72,    76,    77,   141,
     -31,    66,   102,   103,    78,   104,   215,   105,   137,   138,
     190,   110,    70,   103,   111,   112,   113,   114,   115,   116,
      67,   138,    47,     4,     5,     6,     7,     8,     9,    10,
     221,    11,    12,   156,   217,    67,    71,   148,    14,    15,
      16,   161,    80,   145,   227,    17,   155,   145,   230,   231,
     232,   155,    18,    47,   107,   233,   108,    19,    20,    21,
      22,    23,    11,    12,    24,   234,   236,   213,     0,    25,
      26,   153,   101,   219,   102,   103,   216,     0,    66,   218,
     146,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   109,   214,     0,   147,    47,   107,     0,
       0,     0,    67,    66,     0,     0,    11,    12,     0,     0,
       0,    38,     0,     0,    73,     0,     0,     0,     0,   145,
       0,   153,   145,   226,    38,   155,    38,   223,    74,    38,
      38,    38,     0,     0,     0,     0,    38,    67,    75,     0,
       0,    79,    80,   220,     0,     0,     0,     0,    66,    48,
     158,    49,     0,     0,    59,    60,    61,     0,     0,     0,
       0,    65,    92,    93,    94,    95,    96,     0,    97,    98,
      99,   100,   101,   159,   102,   103,   160,     0,     0,     0,
     145,     0,    67,     0,     0,   155,     0,     0,     0,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   235,
       2,    80,     3,     4,     5,     6,     7,     8,     9,    10,
       0,    11,    12,    13,     0,   118,     0,     0,    14,    15,
      16,     0,     0,     0,     0,    17,     0,    97,    98,    99,
     100,   101,    18,   102,   103,     0,     0,    19,    20,    21,
      22,    23,     0,    80,    24,   136,     0,   137,   138,    25,
      26,    47,     4,     5,     6,     7,     8,     9,    10,     0,
      11,    12,     0,     0,     0,     0,     0,    50,    15,    51,
       0,    99,   100,   101,    52,   102,   103,     0,     0,     0,
       0,    18,     0,     0,   118,     0,    53,    54,    55,    22,
      23,    47,     4,    24,     0,     7,     0,     0,    25,    26,
      11,    12,     0,     0,     0,     0,     0,   149,    15,   150,
     132,   133,   134,   135,   136,     0,   137,   138,     0,     0,
       0,    18,     0,     0,     0,     0,     0,   151,   152,    22,
      23,    47,     4,    24,   224,     7,     0,     0,   162,     0,
      11,    12,    47,     4,     0,     0,     7,   149,    15,   150,
       0,    11,    12,     0,     0,     0,     0,     0,   149,    15,
     150,    18,     0,     0,     0,     0,     0,   151,   152,    22,
      23,     0,    18,    24,     0,   117,   118,     0,   151,   152,
      22,    23,   119,   120,    24,     0,     0,     0,   139,     0,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,     0,   132,   133,   134,   135,   136,     0,   137,   138,
      79,    80,     0,     0,     0,     0,   140,    81,    82,     0,
       0,    83,    84,    85,     0,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,     0,    97,    98,    99,
     100,   101,     0,   102,   103,    79,    80,    66,     0,     0,
     142,     0,    81,    82,     0,     0,    83,    84,    85,     0,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,     0,    97,    98,    99,   100,   101,     0,   102,   103,
       0,    67,    79,    80,     0,     0,     0,     0,     0,    81,
      82,   118,     0,    83,    84,    85,     0,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,     0,    97,
      98,    99,   100,   101,     0,   102,   103,    79,    80,   134,
     135,   136,     0,   137,   138,     0,     0,     0,    83,    84,
      85,     0,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,     0,    97,    98,    99,   100,   101,     0,
     102,   103,   117,   118,     0,     0,     0,     0,     0,   119,
     120,     0,     0,     0,     0,    80,     0,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,     0,   132,
     133,   134,   135,   136,     0,   137,   138,    79,    80,    96,
       0,    97,    98,    99,   100,   101,     0,   102,   103,    84,
      85,   118,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,     0,    97,    98,    99,   100,   101,     0,
     102,   103,    79,    80,     0,   131,     0,   132,   133,   134,
     135,   136,     0,   137,   138,    85,     0,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,     0,    97,
      98,    99,   100,   101,     0,   102,   103,   117,   118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,     0,   132,   133,   134,   135,   136,     0,
     137,   138,   117,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,    80,     0,     0,     0,     0,
       0,     0,     0,   127,   128,   129,   130,   131,     0,   132,
     133,   134,   135,   136,     0,   137,   138,    94,    95,    96,
       0,    97,    98,    99,   100,   101,     0,   102,   103,   117,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   130,   131,     0,   132,   133,   134,   135,
     136,     0,   137,   138
};

static const short yycheck[] =
{
       7,    17,    73,    25,    73,    36,    14,    78,     7,    78,
       7,     7,    44,    29,    74,    15,    30,    31,    34,    49,
      51,    14,    45,    46,    15,    39,     4,    43,    45,    46,
      52,    45,    25,    46,    50,    51,    52,    53,    54,    55,
      48,    46,     3,     4,     5,     6,     7,     8,     9,    10,
      33,    12,    13,    50,    50,    48,    49,    71,    19,    20,
      21,    75,    13,    70,     8,    26,    73,    74,    52,     8,
      51,    78,    33,     3,     4,     8,     6,    38,    39,    40,
      41,    42,    12,    13,    45,    52,     0,   139,    -1,    50,
      51,   162,    43,   162,    45,    46,   156,    -1,    14,   159,
      16,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   155,   140,    -1,    42,     3,     4,    -1,
      -1,    -1,    48,    14,    -1,    -1,    12,    13,    -1,    -1,
      -1,     1,    -1,    -1,    25,    -1,    -1,    -1,    -1,   156,
      -1,   222,   159,   222,    14,   162,    16,   217,    39,    19,
      20,    21,    -1,    -1,    -1,    -1,    26,    48,    49,    -1,
      -1,    12,    13,   189,    -1,    -1,    -1,    -1,    14,    14,
      16,    16,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    26,    33,    34,    35,    36,    37,    -1,    39,    40,
      41,    42,    43,    39,    45,    46,    42,    -1,    -1,    -1,
     217,    -1,    48,    -1,    -1,   222,    -1,    -1,    -1,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,     0,
       1,    13,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    13,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    26,    -1,    39,    40,    41,
      42,    43,    33,    45,    46,    -1,    -1,    38,    39,    40,
      41,    42,    -1,    13,    45,    43,    -1,    45,    46,    50,
      51,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
      -1,    41,    42,    43,    26,    45,    46,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    13,    -1,    38,    39,    40,    41,
      42,     3,     4,    45,    -1,     7,    -1,    -1,    50,    51,
      12,    13,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,     3,     4,    45,     6,     7,    -1,    -1,    50,    -1,
      12,    13,     3,     4,    -1,    -1,     7,    19,    20,    21,
      -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    -1,    33,    45,    -1,    12,    13,    -1,    39,    40,
      41,    42,    19,    20,    45,    -1,    -1,    -1,    25,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      12,    13,    -1,    -1,    -1,    -1,    53,    19,    20,    -1,
      -1,    23,    24,    25,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    12,    13,    14,    -1,    -1,
      52,    -1,    19,    20,    -1,    -1,    23,    24,    25,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    12,    13,    -1,    -1,    -1,    -1,    -1,    19,
      20,    13,    -1,    23,    24,    25,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    12,    13,    41,
      42,    43,    -1,    45,    46,    -1,    -1,    -1,    23,    24,
      25,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    12,    13,    -1,    -1,    -1,    -1,    -1,    19,
      20,    -1,    -1,    -1,    -1,    13,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    12,    13,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    24,
      25,    13,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    12,    13,    -1,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    25,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    35,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    35,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 289 "yacc.yy"
{ }
    break;
case 2:
#line 290 "yacc.yy"
{ }
    break;
case 3:
#line 291 "yacc.yy"
{ errored = false; free_dups(); vars.ClearTable();  }
    break;
case 4:
#line 292 "yacc.yy"
{ errored = false; free_dups(); vars.ClearTable();  }
    break;
case 5:
#line 293 "yacc.yy"
{ if( PARM->mach->getLexer()->Isatty() ) { PARM->mach->getLexer()->Flush(); YYABORT; } }
    break;
case 6:
#line 294 "yacc.yy"
{ yyerrok; PARM->mach->getLexer()->SetParsing(false); errored = false; }
    break;
case 7:
#line 300 "yacc.yy"
{ }
    break;
case 8:
#line 301 "yacc.yy"
{ INERR(PARM->mach,"Incomplete statement (No period at EOF)");  }
    break;
case 9:
#line 304 "yacc.yy"
{ if( yyvsp[-1].typeval != NULL ) {  yyvsp[-1].typeval->Fix(); procedure::NewTypeNotify(); if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) { prog_types.Follow(hd).Coerce(yyvsp[-1].typeval); prog_types = prog_types.Follow(tl); } } }
    break;
case 10:
#line 305 "yacc.yy"
{ if( yyvsp[-2].typeval != NULL ) {  yyvsp[-2].typeval->Fix(); procedure::NewTypeNotify(); if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) { prog_types.Follow(hd).Coerce(yyvsp[-2].typeval); prog_types = prog_types.Follow(tl); } } }
    break;
case 11:
#line 306 "yacc.yy"
{ if( yyvsp[-1].typeval != NULL ) {  yyvsp[-1].typeval->Fix(); procedure::NewTypeNotify(); if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) { prog_types.Follow(hd).Coerce(yyvsp[-1].typeval); prog_types = prog_types.Follow(tl); } } }
    break;
case 12:
#line 307 "yacc.yy"
{ if( yyvsp[-2].typeval != NULL ) {  yyvsp[-2].typeval->Fix(); procedure::NewTypeNotify(); if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) { prog_types.Follow(hd).Coerce(yyvsp[-2].typeval); prog_types = prog_types.Follow(tl); } } }
    break;
case 13:
#line 308 "yacc.yy"
{ if( yyvsp[-1].typeval != NULL ) {          vars.ClearTable(); procedure::NewTypeNotify(); if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) { prog_types.Follow(hd).Coerce(yyvsp[-1].typeval); prog_types = prog_types.Follow(tl); } } }
    break;
case 14:
#line 312 "yacc.yy"
{ if( yyvsp[-1].typeval != NULL && yyvsp[0].pval != CORE_P_INVALID ) { yyvsp[-1].typeval->SetAttribute(FSP(PARM->mach, yyvsp[0].pval)); yyval.typeval = yyvsp[-1].typeval; } else yyval.typeval = NULL; }
    break;
case 15:
#line 315 "yacc.yy"
{ yyvsp[-2].typeval->Fix(); }
    break;
case 16:
#line 316 "yacc.yy"
{ yyvsp[-2].typeval->Fix(); }
    break;
case 17:
#line 317 "yacc.yy"
{ INWARN(PARM->mach, "Attribute definition '/' is obsolete; use './' instead"); yyvsp[-2].typeval->Fix(); }
    break;
case 18:
#line 318 "yacc.yy"
{ INWARN(PARM->mach, "Attribute definition '/' is obsolete; use './' instead"); yyvsp[-2].typeval->Fix(); }
    break;
case 19:
#line 322 "yacc.yy"
{ if( yyvsp[-2].typeval != NULL ) yyvsp[-2].typeval->AddFeature(yyvsp[0].appfeatval.feat, yyvsp[0].appfeatval.app); yyval.typeval = yyvsp[-2].typeval; }
    break;
case 20:
#line 323 "yacc.yy"
{ if( yyvsp[-3].typeval != NULL ) yyvsp[-3].typeval->AddFeature(yyvsp[0].appfeatval.feat, yyvsp[0].appfeatval.app); yyval.typeval = yyvsp[-3].typeval; }
    break;
case 21:
#line 324 "yacc.yy"
{ if( yyvsp[-3].typeval != NULL ) yyvsp[-3].typeval->AddFeature(yyvsp[0].appfeatval.feat, yyvsp[0].appfeatval.app); yyval.typeval = yyvsp[-3].typeval; }
    break;
case 22:
#line 325 "yacc.yy"
{ if( yyvsp[-4].typeval != NULL ) yyvsp[-4].typeval->AddFeature(yyvsp[0].appfeatval.feat, yyvsp[0].appfeatval.app); yyval.typeval = yyvsp[-4].typeval; }
    break;
case 23:
#line 326 "yacc.yy"
{ if( yyvsp[-2].typeval != NULL ) yyvsp[-2].typeval->AddFeature(yyvsp[0].appfeatval.feat, yyvsp[0].appfeatval.app); yyval.typeval = yyvsp[-2].typeval; }
    break;
case 24:
#line 330 "yacc.yy"
{ if( yyvsp[-2].typeval != NULL && yyvsp[0].typeval != NULL ) yyvsp[-2].typeval->SetAsChildOf(yyvsp[0].typeval); yyval.typeval = yyvsp[-2].typeval; }
    break;
case 25:
#line 331 "yacc.yy"
{ if( yyvsp[-3].typeval != NULL && yyvsp[0].typeval != NULL ) yyvsp[-3].typeval->SetAsChildOf(yyvsp[0].typeval); yyval.typeval = yyvsp[-3].typeval; }
    break;
case 26:
#line 332 "yacc.yy"
{ if( yyvsp[-2].typeval != NULL && yyvsp[0].typeval != NULL ) yyvsp[-2].typeval->SetAsChildOf(yyvsp[0].typeval); yyval.typeval = yyvsp[-2].typeval; }
    break;
case 27:
#line 336 "yacc.yy"
{ yyval.typeval = bot; }
    break;
case 28:
#line 337 "yacc.yy"
{ yyval.typeval = yyvsp[0].typeval; }
    break;
case 36:
#line 353 "yacc.yy"
{
	if( progalter && !bi_type(yyvsp[0].str))
	{
		yyval.typeval = (type *)module::CurrentModule()->Search(progalter_tprefix + yyvsp[0].str);
		if( yyval.typeval == NULL )
		{
			yyval.typeval = (type *)module::CurrentModule()->Search(yyvsp[0].str);
			if( yyval.typeval != NULL && ! yyval.typeval->IsBuiltIn() )
				yyval.typeval = NULL;
		}
	      }
	else 
	  {
	    yyval.typeval = (type *)module::CurrentModule()->Search((yyvsp[0].str));
	  }
	if( yyval.typeval == NULL ) 
	{
//		INWARN(PARM->mach, "Type '" << $1 << "' is undefined; treated as a subtype of 'bot'");
		yyval.typeval = new type(progalter && !bi_type(yyvsp[0].str) ? (progalter_tprefix + yyvsp[0].str) : (lstring)yyvsp[0].str, module::CurrentModule());
		yyval.typeval->SetAsChildOf(bot);
		yyval.typeval->Fix();
		INWARN(PARM->mach, yyval.typeval->GetProperName() << " <- [bot]. is assumed implicitly");
		procedure::NewTypeNotify();
		if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
			prog_types.Follow(hd).Coerce(yyval.typeval);
			prog_types = prog_types.Follow(tl);
		}
	}
}
    break;
case 37:
#line 383 "yacc.yy"
{
          module *m = module::SearchModule(yyvsp[-1].str);
	  if(m == NULL)
	    {
	      INERR(PARM->mach,"Could not find module " << yyvsp[-1].str << ".");
	      errored = true;
	      yyval.typeval = NULL;
	    }
	  else 
	    {
	      type * m_type = m->Search(yyvsp[0].str);
	      if(m_type == NULL)
		{
		  INERR(PARM->mach,"Could not find atom " << yyvsp[-1].str << ":" << yyvsp[0].str <<".");
		  errored = true;
		  yyval.typeval = NULL;
		}
	      else yyval.typeval = m_type;
	    }
	}
    break;
case 38:
#line 407 "yacc.yy"
{
				type *f =  module::CurrentModule()->Search(yyvsp[0].str);

				if (f == NULL)
				{
					INERR(PARM->mach,"Unknown feature name '" << yyvsp[0].str << "'.");
					errored = true;
					yyval.typeval = NULL;
				}
				else 
					yyval.typeval = (type *)f;
			}
    break;
case 39:
#line 420 "yacc.yy"
{
				module * m = module::SearchModule(yyvsp[-1].str);
				if(m ==NULL)
				{
					INERR(PARM->mach,"Unknown module name '"<< yyvsp[-1].str << "'.");
					errored = true;
					yyval.typeval = NULL;
				}
				else 
				{
				type *f = m->Search(yyvsp[0].str);
					if(f == NULL)
					{
						INERR(PARM->mach,"Unknown feature name '"<< yyvsp[-1].str << ":"<< yyvsp[0].str <<"'.");
						errored = true;
						yyval.typeval = NULL;
					}
					else
						yyval.typeval = f;
				}
			}
    break;
case 40:
#line 444 "yacc.yy"
{ yyval.modval = module::CurrentModule(); }
    break;
case 41:
#line 445 "yacc.yy"
{ yyval.modval = module::SearchModule(yyvsp[0].str); }
    break;
case 42:
#line 450 "yacc.yy"
{ 
			lstring fname = (!bi_type(yyvsp[-2].str)) ? (lstring)yyvsp[-2].str : (progalter_fprefix + yyvsp[-2].str);
			if( (yyval.appfeatval.feat = (feature *)feature::Search(module::CurrentModule()->Search(fname))) == NULL )
			{
				yyval.appfeatval.feat = new feature(fname, yyvsp[-3].modval, 0/*$4*/,module::CurrentModule()->GetInterfaceMode()); 
				if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
					prog_types.Follow(hd).Coerce(yyval.appfeatval.feat->GetRepType());
					prog_types = prog_types.Follow(tl);
				}
			}
			yyval.appfeatval.app = yyvsp[0].typeval;
		}
    break;
case 43:
#line 463 "yacc.yy"
{ 
			lstring fname = (!progalter || bi_feature(yyvsp[-4].str)) ? (lstring)yyvsp[-4].str : (progalter_fprefix + yyvsp[-4].str);
			if( (yyval.appfeatval.feat = (feature *)feature::Search((module::CurrentModule()->Search(fname)))) == NULL )
			{
				yyval.appfeatval.feat = new feature(fname, yyvsp[-5].modval, yyvsp[0].ival,module::CurrentModule()->GetInterfaceMode()); 
				if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
					prog_types.Follow(hd).Coerce(yyval.appfeatval.feat->GetRepType());
					prog_types = prog_types.Follow(tl);
				}
			}
			yyval.appfeatval.app = yyvsp[-2].typeval;
		}
    break;
case 44:
#line 476 "yacc.yy"
{ 
			lstring fname = (!progalter || bi_feature(yyvsp[-6].str)) ? (lstring)yyvsp[-6].str : (progalter_fprefix + yyvsp[-6].str);
			if( (yyval.appfeatval.feat = (feature *)feature::Search((module::CurrentModule()->Search(fname)))) == NULL )
			{
				yyval.appfeatval.feat = new feature(fname, yyvsp[-7].modval, yyvsp[-1].ival,module::CurrentModule()->GetInterfaceMode()); 
				if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
					prog_types.Follow(hd).Coerce(yyval.appfeatval.feat->GetRepType());
					prog_types = prog_types.Follow(tl);
				}
			}
			yyval.appfeatval.app = yyvsp[-4].typeval;
		}
    break;
case 45:
#line 489 "yacc.yy"
{ 
			lstring fname = (!progalter || bi_feature(yyvsp[-4].str)) ? (lstring)yyvsp[-4].str : (progalter_fprefix + yyvsp[-4].str);
			if( (yyval.appfeatval.feat = (feature *)feature::Search((module::CurrentModule()->Search(fname)))) == NULL )
				yyval.appfeatval.feat = new feature(fname, yyvsp[-5].modval, yyvsp[-1].ival,module::CurrentModule()->GetInterfaceMode()); 
			type *tt;
			if( progalter && !bi_type(yyvsp[-2].str) )
			{
				tt = (type *)(yyvsp[-5].modval->Search(progalter_tprefix + yyvsp[-2].str));
				if( tt == NULL )
				{
					tt = (type *)(yyvsp[-5].modval->Search(yyvsp[-2].str));
					if( tt != NULL && ! tt->IsBuiltIn() )
						tt = NULL;
				}
			}
			else
				tt = (type *)yyvsp[-5].modval->Search(yyvsp[-2].str);

			if( tt == NULL ) 
			{
//				INWARN(PARM->mach, "Type '" << $4 << "' is undefined; treated as a subtype of 'bot'");
				tt = new type(yyvsp[-2].str, yyvsp[-5].modval);
				tt->SetAsChildOf(bot);
				tt->Fix();
				INWARN(PARM->mach, tt->GetProperName() << " <- [bot]. is assumed implicitly");
				procedure::NewTypeNotify();
				if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
					prog_types.Follow(hd).Coerce(tt);
					prog_types = prog_types.Follow(tl);
				}
			}
			if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
				prog_types.Follow(hd).Coerce(yyval.appfeatval.feat->GetRepType());
				prog_types = prog_types.Follow(tl);
			}
			yyval.appfeatval.app = tt;
		}
    break;
case 46:
#line 531 "yacc.yy"
{ 
			module::UseCurrentModule();
			lstring tname = !progalter ? (lstring)yyvsp[0].str : (progalter_tprefix + yyvsp[0].str);
			const type *t = module::CurrentModule()->Search(tname);
			if( t != NULL && t->GetModule() == module::CurrentModule() )
			{
				INERR(PARM->mach,"Type '" << yyvsp[0].str << "' is defined twice");
				errored = true;
				yyval.typeval = NULL;
			}
			else
			{
				yyval.typeval = new type(tname,module::CurrentModule(),module::CurrentModule()->GetInterfaceMode()); 
			}
		}
    break;
case 47:
#line 551 "yacc.yy"
{
//		hook();
//		int slot = PARM->mach->GetCurrentSlot();
		bool say_no = false;
		lilfesFlexLexer *prevlexer = PARM->mach->getLexer();
		
		if( yyvsp[-1].pval == CORE_P_INVALID )
		{
			if( ! errored )
				INERR(PARM->mach,"Cannot generate a feature structure");
			errored = true;
		}
		else 
		{
			FSP rfs(PARM->mach, yyvsp[-1].pval);	// root feature structure
			const type *t = rfs.GetType();

			if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() )
			{
//				std::cout << "---" << std::endl;
//				std::cout << rfs.DisplayAVM();
//				std::cout << (ptr_int)rfs.GetType() << std::endl;
//				std::cout << (ptr_int)type::Search(":-/1") << std::endl;

                          // include/1 is no more implemented
// 				if( rfs.GetType() == module::CoreModule()->Search(":-/1") &&
// 					( rfs.Follow(f_cbody).GetType()->IsSubType(module::BuiltinModule()->Search("include")) ) )
// 				{
// 					// Pasted from include/1
// 					FSP arg1 = rfs.Follow(f_cbody).Follow(f_arg[1]);
// 					if( ! arg1.IsString() )
// 					{
// 						INERR(PARM->mach,"include/1 requires a file name");
// 					}
// 					else
// 					{
// 						char *buf = new char[strlen(arg1.ReadString()) + strlen(PARM->mach->getLexer()->InFile())];
// 						char *p;
						
// 						strcpy(buf, PARM->mach->getLexer()->InFile());
// 					#ifdef WIN32
// 						p = strrchr(buf, '\\');
// 					#else
// 						p = strrchr(buf, '/');
// 					#endif
// 						if( p == NULL )
// 							strcpy(buf, arg1.ReadString());
// 						else
// 							strcpy(p+1, arg1.ReadString());
						
// 					//	std::cout << buf << std::endl;
// 						if( (! pushfile( PARM->mach, buf, PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) ) )
// 							if( (! pushfile( PARM->mach, arg1.ReadString(), PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() )) )
// 							{
// 								INERR(PARM->mach,"Cannot open include file: '" << arg1.ReadString() << "'");
// 							}
// 						delete buf;
// 					}
// 				}
//                              else
                          if( rfs.GetType() == module::CoreModule()->Search(":-/1") &&
					(rfs.Follow(f_cbody).GetType()->GetModule() == module::DirectiveModule()) )
				{
					FSP arg1 = rfs.Follow(f_cbody);
					const type *t = arg1.GetType();

					procedure *pc = procedure::Search(t);
					procthunk *pt = pc->GetThunk();
					ASSERT( pt != NULL );

					int nf = t->GetNFeatures();
					PARM->mach->SetRP(nf);
					if( arg1.IsLeaf() )
					{
						for( int i=0; i<nf; i++ )
							PARM->mach->WriteLocal(i, PTR2c(FSP(PARM->mach).GetAddress()));
					}
					else
					{
						for( int i=0; i<nf; i++ )
							PARM->mach->WriteLocal(i, PTR2c(arg1.FollowNth(i).GetAddress()));
					}

					pt->exec(*PARM->mach);
				}
				else {
//				std::cout << "---" << std::endl;
					if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() != 2 )	// 2 means ensure_in_prog...
					{
						prog_list.Follow(hd).Unify(rfs);
						prog_list.Follow(f_lilfesfileinfo)
								 .Follow(f_lilfesfilename)
								 .Unify(FSP(PARM->mach,(const char *)(PARM->mach->getLexer()->InFile())));
						prog_list.Follow(f_lilfesfileinfo)
								 .Follow(f_lilfesfileline)
								 .Unify(FSP(PARM->mach,(mint)(PARM->mach->getLexer()->Lineno())));
						prog_list = prog_list.Follow(tl);
					}
					if( PARM->mach->getLexer()->ProgVars() )
					{
						FSP varlist = prog_vars.Follow(hd);
						for( uint i=0; i<vars.GetTableSize(); i++ )
							if( vars.Pick(i) != NULL && vars.Pick(i)->GetName()[0] != '_')
							{
								FSP v = varlist.Follow(hd);
								v.Follow(hd).Unify(FSP(PARM->mach, vars.Pick(i)->GetName())); 
								v.Follow(tl).Follow(hd).Unify(FSP(PARM->mach, vars.Pick(i)->addr())); 
								v.Follow(tl).Follow(tl).Coerce(nil);
								varlist = varlist.Follow(tl);
							}
						varlist.Coerce(nil);
						prog_vars = prog_vars.Follow(tl);
					}
				}
			}
			else if( rfs.IsLeaf() && t->GetIndex(f_cbody) != -1 )
			{
				INERR(PARM->mach,"Missing clause body");
				errored = true;
			}
			else
			{
				if( rfs.GetType()->IsSubType(t_query) )	// Add DispResult
				{
					FSP varlist(PARM->mach), varlisttop = varlist;
					for( uint i=0; i<vars.GetTableSize(); i++ )
						if( vars.Pick(i) != NULL && vars.Pick(i)->GetName()[0] != '_')
						{
							FSP v = varlist.Follow(hd);
							v.Follow(hd).Unify(FSP(PARM->mach, vars.Pick(i)->GetName())); 
							v.Follow(tl).Follow(hd).Unify(FSP(PARM->mach, vars.Pick(i)->addr())); 
							v.Follow(tl).Follow(tl).Coerce(nil);
							varlist = varlist.Follow(tl);
						}
					varlist.Coerce(nil);

					FSP newrfs(PARM->mach);
					newrfs.Coerce(module::CoreModule()->Search(":-/1"));
					newrfs.Follow(f_cbody).Coerce(module::CoreModule()->Search(","));
					newrfs.Follow(f_cbody).Follow(f_arg[1]).Unify(rfs.Follow(f_cbody));
					newrfs.Follow(f_cbody).Follow(f_arg[2]).Coerce(module::BuiltinModule()->Search("disp_result"));
					newrfs.Follow(f_cbody).Follow(f_arg[2]).Follow(f_arg[1]).Unify(varlisttop);

					rfs = newrfs;
					say_no = true;
				}
				else
				{
					if( t->GetIndex(f_chead) != -1 )
						CheckSingleton(PARM->mach,rfs.Follow(f_chead).GetType()->GetProperName());
					else if( t->IsSubType(t_pred[0]) )
					{
						if( t == t_cut || t == t_comma || t == t_semicolon || t->IsSubType(t_equal) )
						{
							INERR(PARM->mach,t->GetProperName() << " - not redefinable");
							goto ERR_EXIT;
						}
						else
							CheckSingleton(PARM->mach, rfs.GetType()->GetName());
					}
				}

//				std::cout << rfs.DisplayAVM();
				{
					if( t->GetIndex(f_chead) != -1 )
					{
						// p :- q ... Optimize equals
						//PARM->mach->EnableConstraint(true);
						PARM->mach->EnableConstraint(constraint_status);
						while(1) {
							FSP f = rfs.Follow(f_cbody);
							if( f.GetType()->IsSubType(t_equal) )
								if( f.Follow(f_arg[1]).Unify(f.Follow(f_arg[2])) )
								{
									rfs = FSP(rfs.Follow(f_chead));
									break;
								}
								else
								{
									// warn?
									break;
								}
							else 
								if( f.GetType()->IsSubType(t_comma) &&
									f.Follow(f_arg[1]).GetType()->IsSubType(t_equal) )
								{
									FSP g = f.Follow(f_arg[1]);
									if( g.Follow(f_arg[1]).Unify(g.Follow(f_arg[2])) )
									{
										FSP h(PARM->mach);
										h.Follow(f_chead).Unify(rfs.Follow(f_chead));
										h.Follow(f_cbody).Unify(f.Follow(f_arg[2]));
										rfs = h;
										continue;
									}
									else
									{
										// warn?
										break;
									}
								}
								else
									break;
						}
						PARM->mach->EnableConstraint(false);
					}
				}
				
				ShareList sl;
				sl.AddMark(rfs);
				sl.MakeShare();
				
				ptree *pt = GenPTreeOfClause(sl, rfs);
				extern ptree *parsetop; parsetop = pt;
				if( pt != NULL ) 
				{
	#ifdef DEBUG
//					std::cout << pt->OutputTree();
	#endif
					parseinfo *info = new parseinfo(PARM->mach);
					pt->CollectInfo(0, info);
					codelist *l = pt->Compile(0, info);
					l->EndCode();
	#ifdef DEBUG
					if( DEB )
					{
						l->DebugOutput();
						std::cout << "toparg : " << (info->toparg ? info->toparg->GetName() : "(none)") << std::endl;
					}
	#endif
//					if (! strcmp(((pclause *)pt)->GetRepType()->GetSimpleName(), "assert_cky_lexical") )
//						l->DebugOutput();
//					if (! strcmp(((pclause *)pt)->GetRepType()->GetSimpleName(), "unary_rule_check") )
//						l->DebugOutput();

					if( t->GetIndex(f_chead) != -1 || t->IsSubType(pred))	// in case of p :- q...
					{
						procedure *p = procedure::New(((pclause *)pt)->GetRepType(), info->ndefarg);
						if     ( info->is_toparg && info->toparg == t_int )
							p->AddCodelistINT(*l, info->toparg, info->toparg_int);
						else if( info->is_toparg && info->toparg == t_stg )
							p->AddCodelistSTG(*l, info->toparg, info->toparg_stg);
						else
							p->AddCodelist(*l, info->toparg);
					}
					else if( pt->GetClassName() == pclause::className )
					{
	#ifdef DEBUG
					if( DEB )
						{
							std::cout << "@@VARS@@" << std::endl;
							for( size_t i=0; i<vars.GetTableSize(); ++i )
								if( vars.Pick(i) != NULL )
									std::cout << vars.Pick(i)->GetName() << ": " << std::hex << cp2int(vars.Pick(i)->addr()) << std::dec << std::endl;
						}
	#endif
	#if defined(PROFILE)
						delete profx;
	#endif	/* defined(PROFILE) */
						vars.ClearTable();
						bool result;
						{
							P1("Running");
							PARM->mach->EnableConstraint(constraint_status);
							result = PARM->mach->Execute(*l);
							constraint_status = PARM->mach->GetConstraintEnabled();
							PARM->mach->EnableConstraint(false);
						}
						if( say_no )
							(*output_stream) << (result ? "yes" : "no") << std::endl;
	#if defined(PROFILE)
						profx = new prof("Compiling");
	#endif	/* defined(PROFILE) */
					delete[] ((code *)*l);
					}
					delete l;
					delete pt;
					info->hash.ClearTable();
					delete info;
				}
				else
				{
					INERR(PARM->mach,"Cannot generate parse tree");
				}
				if( PARM->mach->getLexer() && ! PARM->mach->getLexer()->ProgInput() )
				{
					PARM->mach->SwitchOldHeap(save);
					PARM->mach->ClearStack();
					save = PARM->mach->SwitchNewHeap();
				}
			}
		}
ERR_EXIT:
		vars.ClearTable();
		if( PARM->mach->getLexer() == prevlexer && ! PARM->mach->getLexer()->IsSkip())
			module::UseCurrentModule();
	}
    break;
case 48:
#line 850 "yacc.yy"
{ 
				const feature *f;

				if( yyvsp[-1].typeval == NULL || (f = feature::Search(yyvsp[-1].typeval)) == NULL || yyvsp[0].pval == CORE_P_INVALID )
				{
					yyval.pval = CORE_P_INVALID;
				} 
				else {
					yyval.pval = PARM->mach->AllocNew(); 
					core_p p = PARM->mach->FollowFeature(yyval.pval, f);
					if( PARM->mach->Unify(p, yyvsp[0].pval) == false )
					{
						INERR(PARM->mach,"Feature '" << f->GetName() << "' is restricted to '" << f->GetBaseType()->GetAppType(f)->GetName() << "', and cannot take '" << FSP(PARM->mach,yyvsp[0].pval).GetType()->GetName() << "'");
						yyval.pval = CORE_P_INVALID;
					      }
				      }
			      }
    break;
case 49:
#line 868 "yacc.yy"
{
				if( yyvsp[0].str[0] == '_' && yyvsp[0].str[1] == '\0' )
				{
					yyval.pval = PARM->mach->AllocNew();
				}
				else
				{
					parsevar *p = vars.Find(yyvsp[0].str);
					if( p == NULL )
					{
						vars.Add(p=new parsevar(yyvsp[0].str, PARM->mach->AllocNew()));
					}
					p->IncCount();
					yyval.pval = p->addr();
				}
			}
    break;
case 50:
#line 885 "yacc.yy"
{
				if( yyvsp[0].typeval == NULL )
					yyval.pval = CORE_P_INVALID;
				else
					yyval.pval = PARM->mach->AllocNew(VAR2c(yyvsp[0].typeval));
//				{ $$ = PARM->mach->AllocNew(); FSP(PARM->mach, $$).Coerce($1);}
			}
    break;
case 51:
#line 893 "yacc.yy"
{
				yyval.pval = yyvsp[-1].pval;
				if( yyvsp[-2].typeval == NULL || yyvsp[-1].pval == CORE_P_INVALID )
				  {
				    yyval.pval = CORE_P_INVALID;
				  }
				else 
				{
					int i;
					type *t1 = yyvsp[-2].typeval;
					type *t2 = (type *)c2STR(PARM->mach->ReadHeap(PARM->mach->Deref(yyvsp[-1].pval)));
					type *t3 = (type *)t1->TypeUnify(t2);
					// Search the arity
					cell c = PARM->mach->ReadHeap(PARM->mach->Deref(yyvsp[-1].pval));
					for( i=0; i<MAXARGS; i++ )
						if( c == STR2c(t_pred[i]) )
							break;

					if( i >= MAXARGS )
						ABORT("Arglist contains unknown type??");
					
					if( t3 == NULL )
					{
						if( t1->TypeUnify(pred) == NULL )
						{
							INERR(PARM->mach,"Type '" << t1->GetName() << "' used as a " << i << "-arity predicate");
							yyval.pval = CORE_P_INVALID;
						}
						else if( t1->TypeUnify(t_pred[1]) == NULL )
						{
							std::ostringstream oss;
							oss << t1->GetSimpleName() << "/" << i;

							if( t1->GetModule()->Search(oss.str().c_str()) )
							{
								INERR(PARM->mach,"Functor " << t1->GetProperName() << " cannot be used;  Existing type " << (t1->GetModule()->Search(oss.str().c_str()))->GetProperName() << " prevents internal type generation");
								yyval.pval = CORE_P_INVALID;
							} else {
								t3 = new type(oss.str().c_str(),t1->GetModule(),t1->IsExported()); t3->SetAsChildOf(t1); t3->SetAsChildOf(t2);
								t3->Fix();
								procedure::NewTypeNotify();
								if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
									prog_types.Follow(hd).Coerce(t3);
									prog_types = prog_types.Follow(tl);
								}
							}
						}
						else
						{ // we have no type for a correct arity
							INERR(PARM->mach,"Predicate '" << t1->GetName() << "' cannot take " << i << "-arity");
							yyval.pval = CORE_P_INVALID;
						}
					}
					else if( i < MAXARGS-1 && t1->TypeUnify(t_pred[i+1]) == t3 )
					{
						// we have no type for a correct arity
						INERR(PARM->mach,"Predicate '" << t1->GetName() << "' cannot take " << i << "-arity");
						yyval.pval = CORE_P_INVALID;
					}
					else if( i==3 && (t1==t_plus || t1==t_minus || t1==t_aster || t1==t_slash || t1==t_intdiv || t1==t_modulo ) )
					{
						INWARN(PARM->mach, "Obsolete Usage of '" << t1->GetName() << "'; use 'is'-expression instead");
					}
					
					if( yyval.pval != CORE_P_INVALID )
						if( PARM->mach->CoerceType(yyvsp[-1].pval, yyvsp[-2].typeval) == false )
						{
							if( yyvsp[-2].typeval != NULL && yyvsp[-1].pval != CORE_P_INVALID )
								ABORT("arglist failed?");
							yyval.pval = CORE_P_INVALID;
						}
				      }
			      }
    break;
case 52:
#line 968 "yacc.yy"
{
				yyval.pval = yyvsp[-1].pval;
			}
    break;
case 53:
#line 972 "yacc.yy"
{
				FSP F(PARM->mach, (mint)yyvsp[0].ival);
				yyval.pval = F.GetAddr();
			}
    break;
case 54:
#line 977 "yacc.yy"
{
				FSP F(PARM->mach, (mfloat)yyvsp[0].dval);
				yyval.pval = F.GetAddr();
			}
    break;
case 55:
#line 982 "yacc.yy"
{
				FSP F(PARM->mach, yyvsp[0].str);
				yyval.pval = F.GetAddr();
			}
    break;
case 57:
#line 990 "yacc.yy"
{
				yyval.pval = yyvsp[-1].pval;
			}
    break;
case 60:
#line 999 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_plus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 61:
#line 1006 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_minus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 62:
#line 1013 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_circm));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 63:
#line 1020 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_aster));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 64:
#line 1027 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_slash));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 65:
#line 1034 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitand));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 66:
#line 1041 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitor));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 67:
#line 1048 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitxor));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 68:
#line 1055 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitnot));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 69:
#line 1061 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_equal));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 70:
#line 1068 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_notuni));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 71:
#line 1075 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_plus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 72:
#line 1081 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_minus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 73:
#line 1087 "yacc.yy"
{
				yyval.pval = yyvsp[-2].pval;
				if( PARM->mach->Unify(yyvsp[-2].pval, yyvsp[0].pval) == false )
				{
					if( yyvsp[-2].pval != CORE_P_INVALID && yyvsp[0].pval != CORE_P_INVALID )
					{
						INERR(PARM->mach,"Cannot unify these two TFSs");
						outform of("Cannot unify: ");
						    of.AddAtRight(FSP(PARM->mach,yyvsp[-2].pval).DisplayAVM());
						of.AddAtRight(outform(" & "));
						    of.AddAtRight(FSP(PARM->mach,yyvsp[0].pval).DisplayAVM());
						std::cout << of;
					}
					yyval.pval = CORE_P_INVALID;
				}
			}
    break;
case 74:
#line 1104 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_means));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_chead), yyvsp[-2].pval) == false
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_cbody), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 75:
#line 1111 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_macro));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 76:
#line 1118 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_means));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_cbody), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 77:
#line 1124 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_query));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(PARM->mach->FollowFeature(yyval.pval, f_cbody), hd), yyvsp[0].pval) == false
				 || PARM->mach->CoerceType(PARM->mach->FollowFeature(PARM->mach->FollowFeature(yyval.pval, f_cbody), tl), nil) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 78:
#line 1131 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_not));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 79:
#line 1137 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_is));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 80:
#line 1144 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_modulo));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 81:
#line 1151 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_intdiv));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 82:
#line 1158 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpl));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 83:
#line 1165 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmple));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 84:
#line 1172 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpg));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 85:
#line 1179 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpge));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 86:
#line 1186 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpeq));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 87:
#line 1193 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpne));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 90:
#line 1205 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_plus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 91:
#line 1212 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_minus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 92:
#line 1219 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_circm));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 93:
#line 1226 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_aster));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 94:
#line 1233 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_slash));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 95:
#line 1240 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitand));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 96:
#line 1247 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitor));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 97:
#line 1254 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitxor));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 98:
#line 1261 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_bitnot));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 99:
#line 1267 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_equal));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 100:
#line 1274 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_notuni));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 101:
#line 1281 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_plus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 102:
#line 1287 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_minus));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 103:
#line 1293 "yacc.yy"
{
				yyval.pval = yyvsp[-2].pval;
				if( PARM->mach->Unify(yyvsp[-2].pval, yyvsp[0].pval) == false )
				{
					if( yyvsp[-2].pval != CORE_P_INVALID && yyvsp[0].pval != CORE_P_INVALID )
					{
						INERR(PARM->mach,"Cannot unify these two TFSs");
						outform of("Cannot unify: ");
						of.AddAtRight(FSP(PARM->mach,yyvsp[-2].pval).DisplayAVM());
						of.AddAtRight(outform(" & "));
						of.AddAtRight(FSP(PARM->mach,yyvsp[0].pval).DisplayAVM());
						std::cout << of;
					}
					yyval.pval = CORE_P_INVALID;
				}
			}
    break;
case 104:
#line 1310 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_means));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_chead), yyvsp[-2].pval) == false
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_cbody), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 105:
#line 1317 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_macro));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 106:
#line 1324 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_means));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_cbody), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 107:
#line 1330 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_query));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_cbody), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 108:
#line 1336 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_not));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 109:
#line 1342 "yacc.yy"
{
				if( yyvsp[-2].pval == CORE_P_INVALID || yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else {
					yyval.pval = PARM->mach->AllocNew(VAR2c(t_comma));
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval);
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval);
				}
			}
    break;
case 110:
#line 1352 "yacc.yy"
{
				if( yyvsp[-2].pval == CORE_P_INVALID || yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else {
					yyval.pval = PARM->mach->AllocNew(VAR2c(t_semicolon));
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval);
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval);
				}
			}
    break;
case 111:
#line 1362 "yacc.yy"
{
				if( yyvsp[-2].pval == CORE_P_INVALID || yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else {
					yyval.pval = PARM->mach->AllocNew(VAR2c(t_ifthen));
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval);
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval);
				}
			}
    break;
case 112:
#line 1372 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_is));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 113:
#line 1379 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_modulo));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 114:
#line 1386 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_intdiv));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 115:
#line 1393 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpl));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 116:
#line 1400 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmple));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 117:
#line 1407 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpg));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 118:
#line 1414 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpge));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 119:
#line 1421 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpeq));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 120:
#line 1428 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew(VAR2c(t_cmpne));
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[-2].pval) == false 
				 || PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[2]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 121:
#line 1438 "yacc.yy"
{
				yyval.pval = PARM->mach->AllocNew();
				if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[1]), yyvsp[0].pval) == false )
					yyval.pval = CORE_P_INVALID;
			}
    break;
case 122:
#line 1444 "yacc.yy"
{
				int i;
				if( yyvsp[-2].pval == CORE_P_INVALID || yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else
				{
					cell c = PARM->mach->ReadHeap(PARM->mach->Deref(yyvsp[-2].pval));
					for( i=0; i<MAXARGS; i++ )
						if( c == STR2c(t_pred[i]) )
							break;
					if( i >= MAXARGS )
						ABORT("Arglist contains unknown type?");
					else if( i == MAXARGS-1 )
						INERR(PARM->mach,"Argument list length over " << MAXARGS);
					else
					{
						yyval.pval = yyvsp[-2].pval;
						if( PARM->mach->Unify(PARM->mach->FollowFeature(yyval.pval, f_arg[i+1]), yyvsp[0].pval) == false )
							yyval.pval = CORE_P_INVALID;
					}
				}
			}
    break;
case 123:
#line 1470 "yacc.yy"
{ yyval.pval = PARM->mach->AllocNew(VAR2c(nil)); }
    break;
case 124:
#line 1472 "yacc.yy"
{ yyval.pval = yyvsp[0].pval; }
    break;
case 125:
#line 1477 "yacc.yy"
{
				if( yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else {
					yyval.pval = PARM->mach->AllocNew();
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, hd), yyvsp[0].pval);
					PARM->mach->CoerceType(PARM->mach->FollowFeature(yyval.pval, tl), nil);
				}
			}
    break;
case 126:
#line 1487 "yacc.yy"
{
				if( yyvsp[-2].pval == CORE_P_INVALID || yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else {
					yyval.pval = PARM->mach->AllocNew();
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, hd), yyvsp[-2].pval);
					if( PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, tl), yyvsp[0].pval) == false )
					{
						INERR(PARM->mach,"Tail of a list is restricted to 'list', and cannot take '" << FSP(PARM->mach,yyvsp[0].pval).GetType()->GetName() << "'");
//						outform of("Containee: ");
//						of.AddAtRight(FSP(PARM->mach, $3).DisplayAVM());
//						std::cout << of;
						yyval.pval = CORE_P_INVALID;
					}
				}
			}
    break;
case 127:
#line 1504 "yacc.yy"
{
				if( yyvsp[-2].pval == CORE_P_INVALID || yyvsp[0].pval == CORE_P_INVALID )
					yyval.pval = CORE_P_INVALID;
				else {
					yyval.pval = PARM->mach->AllocNew();
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, hd), yyvsp[-2].pval);
					PARM->mach->Unify     (PARM->mach->FollowFeature(yyval.pval, tl), yyvsp[0].pval);
				}
			}
    break;
case 128:
#line 1518 "yacc.yy"
{ yyval.typeval= (type *)t_plus; }
    break;
case 129:
#line 1519 "yacc.yy"
{ yyval.typeval= (type *)t_minus; }
    break;
case 130:
#line 1520 "yacc.yy"
{ yyval.typeval= (type *)t_aster; }
    break;
case 131:
#line 1521 "yacc.yy"
{ yyval.typeval= (type *)t_slash; }
    break;
case 132:
#line 1522 "yacc.yy"
{ yyval.typeval= (type *)t_equal; }
    break;
case 133:
#line 1523 "yacc.yy"
{ yyval.typeval= (type *)t_circm; }
    break;
case 134:
#line 1524 "yacc.yy"
{ yyval.typeval= (type *)t_macro; }
    break;
case 135:
#line 1525 "yacc.yy"
{ yyval.typeval= (type *)t_means; }
    break;
case 136:
#line 1526 "yacc.yy"
{ yyval.typeval= (type *)t_query; }
    break;
case 137:
#line 1527 "yacc.yy"
{ yyval.typeval = yyvsp[0].typeval; }
    break;
case 138:
#line 1528 "yacc.yy"
{ yyval.typeval = yyvsp[0].typeval; }
    break;
case 140:
#line 1537 "yacc.yy"
{ 
				if( progalter && !bi_type(yyvsp[0].str) )
				{
					yyval.typeval = (type *)module::CurrentModule()->Search(progalter_tprefix + yyvsp[0].str);
					if( yyval.typeval == NULL )
					{
						yyval.typeval = (type *)module::CurrentModule()->Search(yyvsp[0].str);
						if( yyval.typeval != NULL && ! yyval.typeval->IsBuiltIn() )
							yyval.typeval = NULL;
					}
				}
				else
					yyval.typeval = (type *)module::CurrentModule()->Search(yyvsp[0].str);

				if( yyval.typeval == NULL ) 
				{ // This is predicate; make the entry
//					INWARN(PARM->mach, "Type '" << $1 << "' is undefined; treated as a subtype of 'pred'");
					yyval.typeval = new type(progalter ? (progalter_tprefix + yyvsp[0].str) : (lstring)yyvsp[0].str,module::CurrentModule());
					yyval.typeval->SetAsChildOf(pred);
					yyval.typeval->Fix();
					INWARN(PARM->mach, yyval.typeval->GetProperName() << " <- [pred]. is assumed implicitly");
					procedure::NewTypeNotify();
					if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {

						prog_types.Follow(hd).Coerce(yyval.typeval);
						prog_types = prog_types.Follow(tl);
					}
				}
				else
				{
					if( yyval.typeval->TypeUnify(pred) == NULL )
					{
						INERR(PARM->mach,"Type '" << yyvsp[0].str << "' is not a subtype of 'pred' but used as a predicate");
						yyval.typeval = NULL;
					}
				}
			}
    break;
case 141:
#line 1575 "yacc.yy"
{
                                module *m = module::SearchModule(yyvsp[-1].str);
                                if (m == NULL)
                                        {
					  INERR(PARM->mach,"Unknown module name \"" << yyvsp[-1].str <<"\"");
					  errored = true;
					  yyval.typeval = NULL;
					}
				if( progalter )
				{
					yyval.typeval = (type *)m->Search(progalter_tprefix + yyvsp[0].str);
					if( yyval.typeval == NULL )
					{
						yyval.typeval = (type *)m->Search(yyvsp[0].str);
						if( yyval.typeval != NULL && ! yyval.typeval->IsBuiltIn() )
							yyval.typeval = NULL;
					}
				}
				else
					yyval.typeval = (type *)m->Search(yyvsp[0].str);

				if( yyval.typeval == NULL ) 
				{ // This is predicate; make the entry
//					INWARN(PARM->mach, "Type '" << $2 << "' is undefined; treated as a subtype of 'pred'");
					yyval.typeval = new type(progalter ? (progalter_tprefix + yyvsp[0].str) : (lstring)yyvsp[0].str,m);
					yyval.typeval->SetAsChildOf(pred);
					yyval.typeval->Fix();
					INWARN(PARM->mach, yyval.typeval->GetProperName() << " <- [pred]. is assumed implicitly");
					procedure::NewTypeNotify();
					if( PARM->mach->getLexer() && PARM->mach->getLexer()->ProgInput() ) {
						prog_types.Follow(hd).Coerce(yyval.typeval);
						prog_types = prog_types.Follow(tl);
					}
				}
				else
				{
					if( yyval.typeval->TypeUnify(pred) == NULL )
					{
						INERR(PARM->mach,"Type " << yyvsp[0].str << " is not a subtype of 'pred' but used as a predicate");
						yyval.typeval = NULL;
					}
				}
			}
    break;
case 142:
#line 1621 "yacc.yy"
{ yyval.str = yyvsp[0].str; }
    break;
case 143:
#line 1622 "yacc.yy"
{ 
				yyval.str = my_malloc( strlen(yyvsp[-1].str)+strlen(yyvsp[0].str)+2 );
				strcpy(yyval.str, yyvsp[-1].str);
				strcat(yyval.str, ":");
				strcat(yyval.str, yyvsp[0].str);
			}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1629 "yacc.yy"


struct token_key tokens[] =
{
		{"+", '+'},
		{"-", '-'},
		{"*", '*'},
		{"/", '/'},
		{"=", '='},
		{"&", '&'},
		{"\\", '\\'},
		{"#", '#'},
		{";", ';'},
		{":", ':'},
		{"^", '^'},
		{"<-", SUBSUMED_BY },
		{"?-", QUERY },
		{":-", MEANS },
		{"<=", CMP_LE },
		{"<",  CMP_L },
		{">=", CMP_GE },
		{">", CMP_G },
		{"=:=", CMP_EQ },
		{"=\\=", CMP_NE },
		{":=", MACRO_DEF },
		{"//", INTDIV },
		{"->", IF_THEN },
		{"\\+", NOT },
		{"\\=", NOT_UNIFIABLE },
		{"\\/", BIT_OR },
		{"/\\", BIT_AND },
		{"./",  ATTR_DEF },
		{NULL, 0}
};

StringHash<token_key> *token_hash;


static void init() 
{ 
#ifdef DEBUG
	std::cout << "Initialize " << __FILE__ << std::endl;
#endif
//	input_stream = & std::cin;
//	output_stream = & std::cout;
//	error_stream = & std::cerr;

	token_hash = new StringHash<token_key>;
	for( int i=0; tokens[i].str != NULL; i++ )
	{
//		std::cout << i << " " << tokens[i].str << " " << tokens[i].token_code << std::endl;
		token_hash->Add(& tokens[i]);
	}
}
static void term() 
{ 
/*
	if( input_stream != &std::cin )
		delete input_stream;
	if( output_stream != &std::cout )
		delete output_stream;
	if( error_stream != &std::cerr )
		delete error_stream;
*/
	delete token_hash;
}
static InitFunction IF(init, 100);
static TermFunction TF(term, 100);

void yyerr(machine *m, char* s) {
	INERR(m, s);
}

void machine::parse(lexer_t lex)
{
#ifdef PROFILE
#if PROFILE >= 1
	profx = new prof("Compiling");
#endif
#endif
	save = SwitchNewHeap();
	lexer_t oldlex = getLexer();
#if YYDEBUG
	yydebug = 1;
#endif
	setLexer(lex);
	parser_control parm( this );
        constraint_status = GetConstraintEnabled();
        EnableConstraint( false );  // disable complex constraint during parsing
	while( yyparse(&parm) )
	{
		getLexer()->Flush(); 
		getLexer()->SetFirstRun();
	}
        EnableConstraint( constraint_status );
#ifdef PROFILE
#if PROFILE >= 1
	delete profx;
#endif
#endif
	setLexer(oldlex);
}

void machine::parse()
{
#ifdef PROFILE
#if PROFILE >= 1
	profx = new prof("Compiling");
#endif
#endif
	save = SwitchNewHeap();
	parser_control parm( this );
        constraint_status = GetConstraintEnabled();
        EnableConstraint( false );  // disable complex constraint during parsing
	while( yyparse(&parm) )
	{
		getLexer()->Flush(); 
		getLexer()->SetFirstRun();
	}
        EnableConstraint( constraint_status );
#ifdef PROFILE
#if PROFILE >= 1
	delete profx;
#endif
#endif
}


void CheckSingleton(machine *m, const char *where)
{
	P2("Check Singleton");

	ShareList sl;
	uint i;
	parsevar *p;
	std::ostringstream oss;

	int nsingle = 0;

	for( i=0; i<vars.GetTableSize(); i++ )
		if( (p = vars.Pick(i)) != NULL )
			if( p->GetCount() == 1 && p->GetName()[0] != '_' )
			{
				if( nsingle == 0 )
					oss << "[" << p->GetName();
				else
					oss << ", " << p->GetName();
				nsingle++;
			}

	if( nsingle != 0 )
	{
		oss << "]";

		if( nsingle == 1 )
		{
			INWARN(m, oss.str() << " - singleton variable in " << where);
		}
		else
		{
			INWARN(m, oss.str() << " - singleton variables in " << where);
		}
	}
}

#define STRBUFSIZE 2000

struct strbuf
{
	struct strbuf *next;
	char buf[STRBUFSIZE];
};

static struct strbuf *root = NULL;
static char *bufp = NULL;
static int bufremain = 0;

char *my_malloc(int len)
{
	char *ret;
	struct strbuf *newbuf;
	int buflen;
	
	if( bufremain >= len )
	{
		ret = bufp;
		bufp += len;
		bufremain -= len;
/*		printf("A:%08p\n", ret);*/
		return ret;
	}

	buflen = sizeof(struct strbuf);
	if( len > STRBUFSIZE )
	{
		buflen = buflen - STRBUFSIZE + len;
	}
	
	newbuf = (struct strbuf *)new char[buflen];
	newbuf->next = root;
	root = newbuf;
	bufp = newbuf->buf;
	bufremain = buflen - (sizeof(struct strbuf) - STRBUFSIZE);
	return my_malloc(len);
}


char *my_strdup(char *str)
{
	int len = strlen(str) + 1;

	return strcpy(my_malloc(len), str);
}

void free_dups()
{
/*	printf("F\n");*/
	struct strbuf *next;
	while( root != NULL )
	{
		next = root->next;
		delete[] (char *)root;
		root = next;
	}
	bufp = NULL;
	bufremain = 0;
}

void error_open_file(char *s)
{
	std::cout << "Error: Cannot open input file '" << s << "'" << std::endl;
}

void success_open_file(char *s)
{
	std::cout << s << ":" << std::endl;
}

int token_search(char *str)
{
	token_key *tk;
	tk = token_hash->Find(str);
// std::cout << "TOKEN: " << str << " " << (tk==NULL ? 0 : tk->token_code) << std::endl;
	if( tk == NULL )
		return TOK_ATOM;
	else
		return tk->token_code;
}

} // namespace
