/* $Id: basic.h,v 1.2 2004/02/08 06:35:50 mak Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: basic.h,v 1.2 2004/02/08 06:35:50 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>basic.h</name>
//
///  <overview>
///  <jpn>롼</jpn>
///  <eng>type define routine </eng>
///  </overview>

/// <notiondef>
/// <name> basic_overview </name>
/// <title> 롼 </title>
/// 
/// <desc>
/// 
/// <p> <ref>basic.h</ref>ǤϤ褯Ѥ뷿Ƥޤ<br>
/// </p>
/// </desc>
/// <see> </see>
/// </notiondef>

#ifndef __basic_h
#define __basic_h

#include "lconfig.h"



// Force casting.

#ifdef HAVE_REINTERPRET_CAST
#  define FORCE_CAST(t, i) reinterpret_cast<t>(i)
#else // HAVE_REINTERPRET_CAST
//#define FORCE_CAST(t, i) (*((t) *)(void *)(&(i)))
#  define FORCE_CAST(t, i) (t)(i)
#endif // HAVE_REINTERPRET_CAST



// Function attribute.

#ifdef HAVE_ATTRIBUTE
#define CONSTF const __attrib__(const)
#define CALCF __attrib__(const)    /* Is this right? */
#else
#define CONSTF const
#define CALCF
#endif



// Classes and Types.

namespace lilfes {

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> Version </name>

/// <overview>Сʸ</overview>
/// <desc>
/// <p>
/// СʸǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
extern const char *Version;
/// </body></vardef>

/////////////////////////////////////////////////////////////////////////
/// <vardef>
/// <name> Copyright </name>

/// <overview>ɽ</overview>
/// <desc>
/// <p>
/// ʸǤ褱ФɤäɽƤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
extern const char *Copyright;
/// </body></vardef>



/////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> ushort </name>

/// <overview>unsigned short 饹</overview>
/// <desc>
/// <p>
/// ̵ñ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned short ushort;
/// </body></classdef>


/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> ulong </name>

/// <overview>unsigned long 饹</overview>
/// <desc>
/// <p>
/// ̵饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned long  ulong;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> uchar </name>

/// <overview>unsigned char 饹</overview>
/// <desc>
/// <p>
/// ̵ʸ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned char  uchar;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> uint </name>

/// <overview>unsigned int 饹</overview>
/// <desc>
/// <p>
/// ̵饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned int   uint;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> sshort </name>

/// <overview>signed short 饹</overview>
/// <desc>
/// <p>
/// դñ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef   signed short sshort;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> slong </name>

/// <overview>signed long 饹</overview>
/// <desc>
/// <p>
/// դ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef   signed long  slong;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> schar </name>

/// <overview>signed char 饹</overview>
/// <desc>
/// <p>
/// դʸ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef   signed char  schar;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////

/// <classdef>
/// <name> sint </name>

/// <overview>signed int 饹</overview>
/// <desc>
/// <p>
/// դ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef   signed int   sint;
/// </body></classdef>



// for easy-using of string type

#ifdef HAVE_CSTRING_H
#  include <cstring.h>
#  define repeat_string(a,b) std::string((a),(b))
#else // HAVE_CSTRING_H
#  include <string>
#  ifdef __SUNPRO_CC
#    define string _RW_STD::string
#  endif
#  define repeat_string(a,b) std::string((b),(a))
#endif // HAVE_CSTRING_H

/// <funcdef>
/// <name> int2str </name>
/// <overview> ͤʸѴ</overview>
/// <desc>
/// <p>
/// intͤstringѴޤ
/// </p>
/// </desc>
/// <args> int ͤϤޤ</args>
/// <retval> string֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
std::string int2str(int i);
/// </body></funcdef>



//////////////////////////////////////////////////////////////////////////////
//
//  class code .... actually "unsigned char"
/// <classdef>
/// <name> code </name>
/// <overview> ֥ 饹 </overview>
/// <desc>
/// <p>
/// LiLFeSץȤLiLFeS󥿥ץ꥿֥ɤǤȤ̵ʸ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned char code;
/// </body></classdef>

/// <notiondef>
/// <name> serial_overview </name>
/// <title> ꥢ </title>
/// <desc>
/// <p> LiLFeS ΤʤǤϡ(type)(feature)³(procedure)ʤɤˤ줾˥ˡ ID ƤƤꡢIDΤȤ򥷥ꥢֹȸƤǤޤ<br>
/// </p>
/// </desc>
/// </notiondef>

//////////////////////////////////////////////////////////////////////////////
//
//  class serial .... actually "unsigned short"
/// <classdef>
/// <name> serial </name>

/// <overview> ꥢ륯饹</overview>
/// <desc>
/// <p>
/// Ȥ̵ñ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef unsigned short serial;
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> S_INVALID </name>
/// <overview>̵ʥꥢɽ</overview>
/// <desc>
/// <jpn>
/// <p>
/// б륪֥ȤʤꥢɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// Invalid serial number
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const serial S_INVALID = (serial)-1;	/* Invalid serial number */
/// </body></constdef>

//////////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> tserial </name>
/// <overview> ġtype˰դ˳ƤID Υ饹 </overview>
/// <desc>
/// <p>
/// Ȥ̵16bit饹Ǥtypeˤ˥ˡ˳Ƥ륷ꥢֹǤ
/// </p>
/// </desc>
/// <see>serial_overview</see>
/// <body>
typedef uint16 tserial;	// type serial
/// </body></classdef>

//////////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> fserial </name>
/// <overview> ġfeature˰դ˳ƤID Υ饹 </overview>
/// <desc>
/// <p>
/// Ȥ̵16bit饹Ǥfeatureˤ˥ˡ˳Ƥ륷ꥢֹǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef uint16 fserial;	// feature serial
/// </body></classdef>

//////////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> pserial </name>
/// <overview> ġprocedure˰դ˳ƤID Υ饹</overview>
/// <desc>
/// <p>
/// Ȥ̵16bit饹Ǥ³procedureˤ˥ˡ˳Ƥ륷ꥢֹǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef uint16 pserial;	// procedure serial
/// </body></classdef>

//////////////////////////////////////////////////////////////////////////////
/// <classdef>
/// <name> sserial </name>
/// <overview> ġstring˰դ˳ƤID Υ饹 </overview>
/// <desc>
/// <p>
/// Ȥ̵32bit饹Ǥʸstringˤ˥ˡ˳Ƥ륷ꥢֹǤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
typedef uint32 sserial;	// string serial
/// </body></classdef>

/////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> TS_INVALID </name>
/// <overview>̵tserialɽ </overview>
/// <desc>
/// <jpn>
/// <p>
/// бtype֥ȤʤtserialɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// Invalid tserial number
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const tserial TS_INVALID = (tserial)(-1);	/* Invalid serial number */
/// </body></constdef>

/////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> FS_INVALID </name>
/// <overview>̵fserialɽ </overview>
/// <desc>
/// <jpn>
/// <p>
/// бfeature֥ȤʤfserialɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// Invalid fserial number
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const fserial FS_INVALID = (fserial)(-1);	/* Invalid serial number */
/// </body></constdef>

/////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> PS_INVALID </name>
/// <overview>̵pserialɽ </overview>
/// <desc>
/// <jpn>
/// <p>
/// бprocedure֥ȤʤpserialɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// Invalid pserial number
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const pserial PS_INVALID = (pserial)(-1);	/* Invalid serial number */
/// </body></constdef>

/////////////////////////////////////////////////////////////////////////
/// <constdef>
/// <name> SS_INVALID </name>
/// <overview>̵sserialɽ </overview>
/// <desc>
/// <jpn>
/// <p>
/// бstring֥ȤʤsserialɽǤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// Invalid sserial number
/// </p>
/// </eng>
/// </desc>
/// <see></see>
/// <body>
const sserial SS_INVALID = (sserial)(-1);	/* Invalid serial number */
/// </body></constdef>


//////////////////////////////////////////////////////////////////////////////
//
//  endian manipulation definition

#ifdef BIG_ENDIAN_
/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> Unaligned16 </name>

/// <overview> unaligned ʾ֤ǥ˳ǼƤǡŬڤɤ߹िδؿ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ꡼Τ륢ɥ쥹16bitʬͤҤȤĤ16bitͤȤƼޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <args> ʸؤΥݥ󥿤Ϥޤ</args>
/// <retval> 16bit֤ͤޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int16 Unaligned16(const  char *p) { return (p[0]<<8)+p[1]; }
inline int16 Unaligned16(const uchar *p) { return (p[0]<<8)+p[1]; }
inline int16 Unaligned16(const schar *p) { return (p[0]<<8)+p[1]; }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> Unaligned32 </name>

/// <overview> unaligned ʾ֤ǥ˳ǼƤǡŬڤɤ߹िδؿ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ꡼Τ륢ɥ쥹32bitʬͤҤȤĤ32bitͤȤƼޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <args> ʸؤΥݥ󥿤Ϥޤ</args>
/// <retval> 32bit֤ͤޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int32 Unaligned32(const  char *p) { return (((((p[0] << 8) + p[1]) << 8) + p[2]) << 8) + p[3]; }
inline int32 Unaligned32(const uchar *p) { return (((((p[0] << 8) + p[1]) << 8) + p[2]) << 8) + p[3]; }
inline int32 Unaligned32(const schar *p) { return (((((p[0] << 8) + p[1]) << 8) + p[2]) << 8) + p[3]; }
/// </body></funcdef>
#ifdef HAS_INT64

/// <funcdef>
/// <name> Unaligned64 </name>

/// <overview> unaligned ʾ֤ǥ˳ǼƤǡŬڤɤ߹िδؿ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ꡼Τ륢ɥ쥹64bitʬͤҤȤĤ64bitͤȤƼޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <args> ʸؤΥݥ󥿤Ϥޤ</args>
/// <retval> 64bit֤ͤޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline int64 Unaligned64(const  char *p) { return (((((((((((((p[0] << 8) + p[1]) << 8) + p[2]) << 8) + p[3]) << 8) + p[4]) << 8) + p[5]) << 8) + p[6]) << 8) + p[7]; }
inline int64 Unaligned64(const uchar *p) { return (((((((((((((p[0] << 8) + p[1]) << 8) + p[2]) << 8) + p[3]) << 8) + p[4]) << 8) + p[5]) << 8) + p[6]) << 8) + p[7]; }
inline int64 Unaligned64(const schar *p). { return (((((((((((((p[0] << 8) + p[1]) << 8) + p[2]) << 8) + p[3]) << 8) + p[4]) << 8) + p[5]) << 8) + p[6]) << 8) + p[7]; }
/// </body></funcdef>
#endif
#else
inline int16 Unaligned16(const  char *p) { return (int16)(((uint)p[1]<<8)+(uint)p[0]); }
inline int16 Unaligned16(const uchar *p) { return (int16)(((uint)p[1]<<8)+(uint)p[0]); }
inline int16 Unaligned16(const schar *p) { return (int16)(((uint)p[1]<<8)+(uint)p[0]); }
inline int32 Unaligned32(const  char *p) { return (((((p[3] << 8) + p[2]) << 8) + p[1]) << 8) + p[0]; }
inline int32 Unaligned32(const uchar *p) { return (((((p[3] << 8) + p[2]) << 8) + p[1]) << 8) + p[0]; }
inline int32 Unaligned32(const schar *p) { return (((((p[3] << 8) + p[2]) << 8) + p[1]) << 8) + p[0]; }
#ifdef HAS_INT64
inline int64 Unaligned64(const  char *p) { return (((((((((((((p[7] << 8) + p[6]) << 8) + p[5]) << 8) + p[4]) << 8) + p[3]) << 8) + p[2]) << 8) + p[1]) << 8) + p[0]; }
inline int64 Unaligned64(const uchar *p) { return (((((((((((((p[7] << 8) + p[6]) << 8) + p[5]) << 8) + p[4]) << 8) + p[3]) << 8) + p[2]) << 8) + p[1]) << 8) + p[0]; }
inline int64 Unaligned64(const schar *p) { return (((((((((((((p[7] << 8) + p[6]) << 8) + p[5]) << 8) + p[4]) << 8) + p[3]) << 8) + p[2]) << 8) + p[1]) << 8) + p[0]; }
#endif
#endif

} // namespace lilfes

#endif // __basic_h
