/* $Id: lilfes.h,v 1.3 2004/02/08 15:08:40 mak Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: lilfes.h,v 1.3 2004/02/08 15:08:40 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>lilfes.h</name>
//
///  <overview>
///  <jpn>O痘p邽߂̃wb_t@C</jpn>
///  <eng>Header-file for external programs</eng>
///  </overview>

#ifndef __lilfes_h
#define __lilfes_h

#include "ftype.h"
#include "structur.h"
#include "lexer.h"

namespace lilfes {

/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> parse </name>

/// <overview>LiLFeS p[U[̎s</overview>
/// <desc>
/// <jpn>
/// <p>
/// LiLFeS p[U[s܂Bł́Avvg\A͂܂ɂȂ܂B
/// </p>
/// </jpn>
/// </desc>

/// <body>
inline void parse(machine *m, lexer_t l) { return m->parse(l); }
inline void parse(machine *m) { return m->parse(); }
/// </body></funcdef>


/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> eval </name>

/// <overview>̕]</overview>
/// <desc>
/// <jpn>
/// <p>
/// ]āAlist 킷 FSP ɂĕԂ܂BB
/// </p>
/// </jpn>
/// </desc>

/// <body>
inline FSP eval(machine *m, const char *s) { return m->eval(s); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////

/// <funcdef>
/// <name> call </name>

/// <overview>q̎s</overview>
/// <desc>
/// <jpn>
/// <p>
/// FSP s܂B
/// </p>
/// </jpn>
/// </desc>

/// <body>
inline bool call(machine *m, FSP f) { return m->call(f); }
/// </body></funcdef>


}

#endif
