/* $Id: machine.h,v 1.6 2004/09/13 12:47:35 n165 Exp $
 *
 *    Copyright (c) 1997-1998, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */
///  <ID>$Id: machine.h,v 1.6 2004/09/13 12:47:35 n165 Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>machine.h</name>
//
///  <overview>
///  <jpn>ݵ</jpn>
///  <eng>abstract machine </eng>
///  </overview>

/// <notiondef>
///
/// <name> stack_overview </name><title> StackˤĤ </title>
/// <desc>
/// <p>ݵˤϽҸθƤӽФꥢɥ쥹ʤɤ뤿ΥåޤåˤĤޤǡϥե졼ñ̤ǰޤե졼ˤAND-STACKե졼OR-STACKե졼ΣΥåե졼बޤ</p>
///
/// 
/// <B>AND-STACK</B><BR>
/// <P>AND-STACKϡҸθƤӽФǥѿƤꡢҸ줫Ȥν˻Ȥ롢륹åǤ</P>

/// <P><TABLE BORDER=3 CELLPADDING=5>
/// <CAPTION>AND-STACKΥåե졼˳Ǽ</CAPTION>
/// <TR><TD>CIP(Continuation Instruction Point)</TD><TD>äƤ٤codeΥɥ쥹</TD></TR>
/// <TR><TD>FP(continuation environment Frame Pointer)</TD><TD>äƤ٤ե졼ؤΥݥ</TD></TR>
/// <TR><TD>Y1(permanent variable 1)</TD><TD>³ѿ</TD></TR>
/// <TR ALIGN=center><TD></TD><TD></TD></TR>
/// <TR ALIGN=center><TD></TD><TD></TD></TR>
/// <TR ALIGN=center><TD></TD><TD></TD></TR>
/// <TR><TD>Yn(permanent variable 1)</TD><TD>³ѿn</TD></TR>
/// </TABLE></P>

/// <BR>

/// <P>ȤưʲΤ褦ʥץबäȤޤ<BR>
/// <TABLE BORDER=0 CELLPADDING=0 BGCOLOR=white>
/// <TR><TH>ץֹ</TH><TH>ץ</TH></TR>
/// <TR> <TD ALIGN=center>1:</TD><TD>A(X,Y) :- B(X),C(Y).</TD> </TR>
/// <TR> <TD ALIGN=center>2:</TD><TD>B(X) :- E(X).</TD> </TR>
/// <TR> <TD ALIGN=center>3:</TD><TD>C(1).</TD> </TR>
/// <TR> <TD ALIGN=center>4:</TD><TD>E(2).</TD> </TR>
/// </TABLE></P>

/// <P>Τ褦ˡҸA,B,C,E,FäȤޤƽҸAFƤФ줿Ȥ˼¹Ԥ٤ǼƤ̿᥷(code)򤽤줾Inst_AInst_FȤޤĤ˰Ĥ̿᥷󥹤бޤ
/// ̿᥷󥹤Ƭ֤˼¹Ԥޤ˼¹Ԥ̿ؤƤΤ쥸IPǤȤƣܤб̿᥷󥹤Ԥʲ˼ޤ</P>

/// <P><TABLE BORDER=3 CELLPADDING=5>
/// <CAPTION>A(X,Y) :- B(X),C(Y).ɤб̿᥷󥹡</CAPTION>
/// <TR><TH><NOBR>ֹ</NOBR></TH><TH>Ԥ</TH><TH></TH></TR>
/// <TR><TD></TD><TD><NOBR>åե졼Push</NOBR></TD><TD>ʬΥåե졼ޤ</TD></TR>
/// <TR><TD></TD><TD>XѤΰ衡ƤФ줿A裱</TD><TD>local[1]äƤA裱XѤΰ˳Ǽޤ</TD></TR>
/// <TR><TD></TD><TD>YѤΰ衡ƤФ줿A2</TD><TD>local[2]äƤA裲YѤΰ˳Ǽޤ</TD></TR>
/// <TR><TD></TD><TD>local</TD><TD>localޤ</TD></TR>
/// <TR><TD></TD><TD>local[1]XѤΰ</TD><TD>XѤΰäƤXͤlocal[1]˳Ǽޤ</TD></TR>
/// <TR><TD></TD><TD>ҸBƤ</TD><TD>ҸBƤӤޤ</TD></TR>
/// <TR><TD></TD><TD>local</TD><TD>localޤ</TD></TR>
/// <TR><TD></TD><TD>local[1]YѤΰ</TD><TD>YѤΰäƤYͤlocal[1]˳Ǽޤ</TD></TR>
/// <TR><TD></TD><TD>ҸCƤ</TD><TD>ҸCƤӤޤ</TD></TR>
/// <TR><TD></TD><TD>åե졼Pop</TD><TD>ǽPushåե졼ޤ</TD></TR>
/// <TR><TD></TD><TD></TD><TD>¹Ծ(쥸IP)ƤӽФᤷޤ</TD></TR>
/// </TABLE></P>
/// <P>οޤǡXѤΰɤYѤΰɤȤޤҸθƤӽФޤѿˤĤƤϥåե졼ࡢǤʤΤlocalΰäƤȤΰ衢ΤȤǤܤ<ref>variable_overview</ref>򻲾ȤƤ</P>


/// <P>ˡΥץ¹Ԥ硣</P>
/// <P>ץࣱܡҸAǡҸBƤӽФƤΤǡA̿᥷Inst_A̿ᣳ顢B̿᥷Inst_B̿ᣱ˼¹Բս꤬ܤޤʲޭƱͤ˥ץΣܡҸBǡҸEƤӽФƤΤǡB̿᥷Inst_B̿ᣴ顢E̿᥷Inst_E̿ᣱ˼¹Բս꤬ܤޤʲޭInst_Eμ¹ԤǸޤǹԤInst_B̿ᣵ˼¹Բս꤬ޤʲޭˤInst_Bμ¹ԤǸޤǹԤInst_A̿ᣴޤʲޭˤǥץࣱܤνҸBθƤӽФꡢ˽ҸCƤФޤ<BR>
/// <B><I>̿᥷󥹤̿οϲͶΤΤǡɬºݤ̿Ȥϸ¤ޤ</I></B></P>

/// <P><IMG SRC=./and_exec.gif></P><BR><BR>
/// <P>ץ¹ԤΥåΰܤѤ<a href="j-and_stack_1.html" target="and_stack">̥ɥ</a>ǼޤΤʤ̤νҸ줬ƤФ¹Բս꤬֤Ȥʭ,̿ᣱǥåե졼ब졢쥸FPϿ줿åե졼ؤ褦ˤʤޤCIPˤäƤȤ˼¹ԤɤƳ뤫FPϤɤΥåե졼ФY1...YnˤѿǽҸθƤӽФޤΡʥץࣱܤǤYˤǼޤ¹Բս꤬ȤξäƤȤʭˡɤ긵κǸ̿ǡΥåե졼ΥեFP쥸FPȤΥåե졼˴ޤʭˡ</P>


/// <BR><HR WIDTH=100%><!-- OR-STACK------------------------------------------------------------------------- -->
/// <B>OR-STACK</B><BR>
/// <P>OR-STACKʣ¸ߤҸˤĤƥХåȥåȤˡȤ륹åǤ
/// ʣ褬硢ʬOR-STACKΥåե졼बޤåե졼ˤϼΤ褦ʾ󤬳Ǽޤ</P>
/// 

/// <P><TABLE BORDER=3 CELLPADDING=5 BGCOLOR=white>
/// <CAPTION>OR-STACKΥåե졼˳Ǽ</CAPTION>
/// <TR><TD>OP</TD><TD>OR-STACKե졼ؤΥݥ</TD></TR>
/// <TR><TD>RETP</TD><TD>˻̿᥷󥹤ؤΥݥ</TD></TR>
/// <TR><TD>CIP</TD><TD>äƤ٤codeΥɥ쥹</TD></TR>
/// <TR><TD>FP</TD><TD>äƤ٤ե졼ؤΥݥ</TD></TR>
/// <TR><TD>TP</TD><TD>ȥ쥤topؤݥ</TD></TR>
/// <TR><TD>HA</TD><TD>choice point ǤHA򤷤Ƥ</TD></TR>
/// <TR><TD>HP</TD><TD>choice point ǤHP򤷤Ƥ </TD></TR>
/// <TR><TD>B0</TD><TD>ҡ׾Υȥ쥤뤬ɬפΰȤǤʤΤȤζ</TD></TR>
/// <TR><TD>RP</TD><TD>Ҹΰο</TD></TR>
/// <TR><TD>A1</TD><TD>Ҹ裱</TD></TR>
/// <TR><TD></TD><TD></TD></TR>
/// <TR><TD></TD><TD></TD></TR>
/// <TR><TD></TD><TD></TD></TR>
/// <TR><TD>An</TD><TD>Ҹn</TD></TR>
/// </TABLE></P>


/// <P>ȤưʲΤ褦ʥץबäȤޤ<BR>
/// <TABLE BORDER=0 CELLPADDING=0 BGCOLOR=white>
/// <TR><TH>ץֹ</TH><TH><BR></TH></TR>
/// <TR> <TD>1:</TD><TD>A(X,Y) :- B(X),C(Y).</TD> </TR>
/// <TR> <TD>2:</TD><TD>C(1).</TD> </TR>
/// <TR> <TD>3:</TD><TD>B(X) :- E(X).</TD> </TR>
/// <TR> <TD>4:E-1</TD><TD>E(X) :- F(X).</TD> </TR>
/// <TR> <TD>5:E-2</TD><TD>E(X) :- G(X).</TD> </TR>
/// <TR> <TD>6:E-3</TD><TD>E(X) :- H(X).</TD> </TR>
/// <TR> <TD>7:</TD><TD>F(2).</TD> </TR>
/// <TR> <TD>8:</TD><TD>G(1).</TD> </TR>
/// <TR> <TD>9:</TD><TD>H(3).</TD> </TR>
/// </TABLE></P>

/// <P>ҸBˤĤƤ᤬ʣޤΤ褦ʽҸˤϡȥ󥹥ɤȤcode󤬺ޤ(Ent_B)ȥ󥹥ɤϰŪ˰ʲΤ褦ˤʤäƤޤ</P>
/// <P><TABLE BORDER=3 CELLPADDING=5>
/// <TR><TH>̿</TH><TH></TH></TR>
/// <TR><TD>TRYAT</TD><TD>OR-STACKꡢǽ</TD></TR>
/// <TR><TD>RETRYAT</TD><TD>ɬפʾ򸵤ᤷOR-STACKΥեRETP򹹿(˻̿᥷󥹤ؤ褦ˤ)ʣܰʹߤǺǸϽˤΥɤο-2ʺǽȺǸϽΤǡˡĺޤ</TD></TR>
/// <TR><TD>LAST</TD><TD>ɬפʾ򸵤ᤷOR-STACK˴Ǹ</TD></TR>
/// </TABLE></P>

/// <P><IMG SRC="./or_exec.gif"></P>

/// <P>᤬ʣҸ죱ĤˤĤơʥȥ󥹥ɣĤˤĤơˣĤOR-STACKޤץ¹ԤΥåΰܤѤ<a href="j-or_stack_1.html" target="or_stack">̥ɥ</a>Ǽޤ</P>

/// </desc>
/// <see>machine.h</see>
/// </notiondef>


////////////////////////////////////////////////////////////////////////////////////////////////
/// <notiondef>
///
/// <name> cut_overview </name><title> CutˤĤ </title>
/// <desc>
/// <P>CutȤʣĽҸ˴ؤơOR-STACKե졼̵ˤΤȤǤ</P>
/// <P>㣱ʲΤ褦ʽҸpäȤޤҸpʣĤΤǡҸpѤOR-STACKե졼बޤǽ᤬failȡ˼¹ԤܤޤCut¹Ԥ졢ҸpѤOR-STACKե졼ब̵ˤޤŪˤϥ쥸OPĲOR-STACKե졼ؤ褦ˤޤ(쥸OP˥쥸B0ͤ뢪<ref>C_SHALCUT</ref>)
/// <TABLE BORDER=0 >
/// <TR><TD>p :- a.</TD></TR>
/// <TR><TD>p :- !,b,c.</TD></TR>
/// <TR><TD>p :- d.</TD></TR>
/// </TABLE>
/// <P><TABLE BORDER=3 CELLPADDING=5>
/// <CAPTION><NOBR>ڣܤ̿᥷󥹡</NOBR></CAPTION>
/// <TR><TD><ref>C_ALLOC</ref> 0 1</TD><TD>AND-STACKե졼</TD></TR>
/// <TR><TD><ref>C_SHALCUT</ref></TD><TD>쥸OP˥쥸B0ͤ</TD></TR>
/// <TR><TD><ref>C_CALL</ref> b</TD><TD>bƤ</TD></TR>
/// <TR><TD><ref>C_CLRTEMP</ref> 1</TD><TD>local[0]</TD></TR>
/// <TR><TD><ref>C_DEALLOC</ref></TD><TD>AND-STACKե졼˴</TD></TR>
/// <TR><TD><ref>C_EXECUTE</ref> c</TD><TD>cƤRETURN</TD></TR>
/// </TABLE></P><BR><BR>

/// </P>
/// <P>㣲ʲΤ褦ʽҸpäȤޤξ磲ܤCut¹Ԥǡ쥸B0ɬҸpѤOR-STACKե졼ΣOR-STACKե졼ؤƤȤϸ¤ʤΤǡܤκǽλǤΥ쥸B0local⤷ϡAND-STACKե졼¸Ƥ(<ref>C_GETLEVEL</ref>)Cut¹ԤȤϡΤȤäƤB0ͤ쥸OPޤ<ref>C_DEEPCUT</ref>
/// <TABLE BORDER=0 >
/// <TR><TD>p :- a.</TD></TR>
/// <TR><TD>p :- b,!,c.</TD></TR>
/// <TR><TD>p :- d.</TD></TR>
/// </TABLE>
/// <P><TABLE BORDER=3 CELLPADDING=5>
/// <CAPTION><NOBR>ڣܤ̿᥷󥹡</NOBR></CAPTION>
/// <TR><TD><ref>C_ALLOC</ref> 1 1</TD><TD>AND-STACKե졼</TD></TR>
/// <TR><TD><ref>C_GETLEVEL</ref> PERM-1</TD><TD>쥸B0PERM-1¸</TD></TR>
/// <TR><TD><ref>C_CALL</ref> b</TD><TD>bƤ</TD></TR>
/// <TR><TD><ref>C_CLRTEMP</ref> 1</TD><TD>local[0]</TD></TR>
/// <TR><TD><ref>C_DEEPCUT</ref> PERM-1</TD><TD>쥸OP򤳤äǤB0ͤˤ</TD></TR>
/// <TR><TD><ref>C_DEALLOC</ref></TD><TD>AND-STACKե졼˴</TD></TR>
/// <TR><TD><ref>C_EXECUTE</ref> c</TD><TD>cƤRETURN</TD></TR>
/// </TABLE></P><BR><BR>

/// </P>
/// <P>㣱Τ褦κǽΤۤCutΤ"Shallow cut"ȸƤӡ㣲Τ褦ˣܰʹߤCutΤ"Deep cut"ȸƤӤޤ</P>
/// <P>Cutifʸθ̤ΤˤȤޤ<BR>

/// <TABLE BORDER=1 CELLPADDING=5>
/// <TR><TH>ץࣱ</TH><TH>ץࣲ</TH></TR>
/// <TR><TD>p :- a -> b;c.</TD><TD>p :- q.<BR>q :- a,!,b.<BR>q :- c.</TD></TR>
/// </TABLE>

/// ץࣱϡab,ǤʤcפȤ̣ǡץࣲǤaDeep cut Ȥ쥸OPҸpΤϤλǤΣ־OR-STACKե졼ؤ褦ˤʤȤޤ󡣤Τ˥쥸OPlocal⤷ϡAND-STACKե졼¸Ƥcode<ref>C_GETCP</ref>Ǥ
/// <P><TABLE BORDER=3 CELLPADDING=5>
/// <CAPTION><NOBR>ڥץࣱ̿᥷󥹡</NOBR></CAPTION>
/// <TR><TD>0</TD><TD><ref>C_ALLOC</ref> 1 1</TD><TD>AND-STACKե졼</TD></TR>
/// <TR><TD>5</TD><TD><ref>C_GETCP</ref> PERM-1</TD><TD>쥸OPPERM-1¸</TD></TR>
/// <TR><TD>8</TD><TD><ref>C_TRY</ref> @31</TD><TD>aơԤ31֡</TD></TR>
/// <TR><TD>13</TD><TD><ref>C_CALL</ref> a</TD><TD>aƤ</TD></TR>
/// <TR><TD>16</TD><TD><ref>C_CLRTEMP</ref> 1</TD><TD>local[0]</TD></TR>
/// <TR><TD>19</TD><TD><ref>C_DEEPCUT</ref> PERM-1</TD><TD>쥸OP򤳤äǤ᤹ͤ</TD></TR>
/// <TR><TD>22</TD><TD><ref>C_DEALLOC</ref></TD><TD>AND-STACKե졼˴</TD></TR>
/// <TR><TD>23</TD><TD><ref>C_EXECUTE</ref> b</TD><TD>bƤRETURN</TD></TR>
/// <TR><TD><S>26</S></TD><TD><S><ref>C_JUMP</ref> @36</S></TD><TD>ʼ¹Ԥʤ</TD></TR>
/// <TR><TD>31</TD><TD><ref>C_LASTTRY</ref></TD><TD>aƤξ֤ˤɤOR-STACKե졼˴</TD></TR>
/// <TR><TD>32</TD><TD><ref>C_DEALLOC</ref></TD><TD>AND-STACKե졼˴</TD></TR>
/// <TR><TD>33</TD><TD><ref>C_EXECUTE</ref> c</TD><TD>cƤRETURN</TD></TR>
/// <TR><TD><S>36</S></TD><TD><S><ref>C_CLRTEMP</ref> 1<S></TD><TD>ʼ¹Ԥʤ</TD></TR>
/// <TR><TD><S>39</S></TD><TD><S><ref>C_DEALLOC</ref></S></TD><TD>ʼ¹Ԥʤ</TD></TR>
/// <TR><TD><S>40</S></TD><TD><S><ref>C_RETURN</ref></S></TD><TD>ʼ¹Ԥʤ</TD></TR>
/// </TABLE></P><BR><BR>

/// </P>
/// </desc>
/// <see>code.h</see>
/// </notiondef>


#ifndef __machine_h
#define __machine_h

#include "lconfig.h"

#undef B0

#include "cell.h"
#include "code.h"
#include "outform.h"
#include "lexer.h"
#include <vector>
#if defined(HAVE_EXT_HASH_MAP)
#include <ext/hash_map>
#elif defined(HAVE_HASH_MAP)
#include <hash_map>
#else
#error NO HEADER for hash_map
#endif

// Continuation Frame Offsets

namespace lilfes {

const bool USE_MULTIPLY = 1;

const int ALLOC_STEP = (1024*2048*4);

#if SIZEOF_INT == SIZEOF_INTP
const int  CODESIZEONSTACK = 1;
#elif SIZEOF_INT * 2 == SIZEOF_INTP
const int  CODESIZEONSTACK = 2;
#else
#error size of code* is bad!!
#endif

const int  CF_OP_OFFSET		=(0);
const int  CF_RETP_OFFSET	=(1);
const int  CF_CIP_OFFSET	=(1+CODESIZEONSTACK);
const int  CF_FP_OFFSET		=(1+CODESIZEONSTACK*2);
const int  CF_TP_OFFSET		=(1+CODESIZEONSTACK*2+1);
const int  CF_HA_OFFSET		=(1+CODESIZEONSTACK*2+2);
const int  CF_HP_OFFSET		=(1+CODESIZEONSTACK*2+3);
const int  CF_B0_OFFSET		=(1+CODESIZEONSTACK*2+4);
const int  CF_RP_OFFSET		=(1+CODESIZEONSTACK*2+5);
const int  CF_LOCAL_OFFSET	=(1+CODESIZEONSTACK*2+6);

// Stack Frame Offsets

const int  SF_CIP_OFFSET	=(-(CODESIZEONSTACK));
const int  SF_FP_OFFSET		=(0);
const int  SF_LOCAL_OFFSET	=(1);



////////////////////////////////////////
//  class core
//
/// <classdef>
/// <name> core </name>
/// <overview> LiLFeS ݵΥɽ饹</overview>
/// <desc>
/// <p>
/// LiLFeS ݵΥޤȤ<ref>cell</ref>1Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class core
{
	cell *mem;
	uint size;
	lstring name;

	static const uint initCoreSize;
	static const uint maxCoreSize;
	
public:
		core(const char *iname = NULL, uint is = initCoreSize);
  /// <var>iname</var>coreinitial name<br>
  /// <var>is</var>cellinitial size
		~core();

	void SetName(const char *iname) { name = iname; }
  /// ̾ꤷޤ
	void SetTo(const core &c) { mem = c.mem; size = c.size; }
  /// δؿϸ(2001/09/02)ȤƤޤ
//	cell * operator*() CONSTF { return mem; }   // operator* can't assert bound on index, so don't use

	cell & operator[](core_p index) CALCF
			{ ASSERT(index < size); return mem[index]; }
	const cell & operator[](core_p index) CONSTF
			{ ASSERT(index < size); return mem[index]; }
  /// 1ǤcoreǤ򻲾Ȥޤ<var>index</var>,0sizeޤǤǤ
  

	uint GetSize() CALCF { return size; }
  /// ޤ
	void Resize(uint newsize);
  /// ĥޤ<var>newsize</var>˳ĥޤĥΤߤǸ餹ȤϤǤޤ
	outform OutputCore(int start, int end);
  /// coreȤɽޤcell1Ȥɽޤ
	outform OutputStack(int start, int end, int fp=-1000, int op=-1000);
  /// coreϥåȤƤѤޤλ˥åȤȤɽΤ˻ѤޤcellλỊ̇⤢ɽޤ
};
/// </body></classdef>

////////////////////////////////////////
//
//  class machine
//
//  Abstract machine class.

#define NHEAP	 4
#define HEAPSTRIDE	0x10000000U
//#define MAKE_COREP(slot, addr) (int2cp(((slot)<<27)+(addr)))
#define STACK (heap[NHEAP-1])
#define STACK_BASE ((NHEAP-1)*HEAPSTRIDE)

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> GetSlot </name>
/// <overview>core_pؤcellܤheapޤ </overview>
/// <desc><jpn>
/// <p>
/// core_pؤcellܤslotˤ뤫Ĵ٤ޤ
/// </p>
/// </jpn></desc>
/// <args> core_p֥ȤϤޤ</args>
/// <retval> slot()֤ޤ </retval>
/// <remark></remark>
/// <body>
inline int GetSlot(core_p cp) { return ((uint32)cp2int(cp) >> 28); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> GetOffset </name>
/// <overview> core_pؤcellåƬ鲿ܤޤ </overview>
/// <desc><jpn>
/// <p>
/// core_pؤcellåƬ鲿ܤޤ
/// </p>
/// </jpn></desc>
/// <args> core_p֥ȤϤޤ</args>
/// <retval> offset(core_p֥)֤ޤ </retval>
/// <remark></remark>
/// <body>
inline core_p GetOffset(core_p cp) { return int2cp(((uint32)cp2int(cp) & 0x0fffffffU)); }
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> MakeCoreP </name>
/// <overview> slotoffsetcore_pޤ </overview>
/// <desc>
/// <jpn>
/// <p>
/// åȤȥեåȤ顢륻ؤɥ쥹(core_p֥)ޤ<BR>
/// Գ(å)Ȼ(եå)顢ֹ(core_p)봶Ǥ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <args> slot()Ϥޤ</args>
/// <retval> core_p֥Ȥ֤ޤ </retval>
/// <remark></remark>
/// <see></see>
/// <body>
inline core_p MakeCoreP(int slot, core_p offset) { return int2cp((slot<<28)+cp2int(offset)); }
/// </body></funcdef>

class FSP;
class codelist;

//class machine;
//typedef void (FASTCALL machine::*machine_function_p)(void);
////////////////////////////////////////
//
/// <classdef>
/// <name> machine </name><overview>ݵ 饹</overview>
/// <desc>
/// <p>

/// <TABLE BORDER=1 CELLPADDING=5 >
/// <TR VALIGN=top>
/// <TD ROWSPAN=2>

/// <TABLE BORDER=2 CELLPADDING=5>
/// <CAPTION>ڥҡס</CAPTION>
/// <TR ALIGN=center> <TD>heap[0]</TD><TD><NOBR></NOBR></TD> </TR>
/// <TR ALIGN=center> <TD>heap[1]</TD><TD></TD> </TR>
/// <TR ALIGN=center> <TD>heap[2]</TD><TD></TD> </TR>
/// <TR ALIGN=center> <TD>heap[NHEAP-1]</TD><TD></TD> </TR>
/// </TABLE>
/// ҡפΣĤǡʰ³΢)ϡĤ<ref>core</ref>֥Ȥбޤ<BR>
/// Ĥ""ϣĤ<ref>cell</ref>֥Ȥбޤ<BR>
/// <BR>ƥҡפ<BR>
/// heap[0] = globalѿǼ뤿Υҡ<BR>
/// heap[1] = startȤΥҡ<BR>
/// <NOBR>heap[2] = findallƤӽФȤ˻Ȥҡ</NOBR><BR>
/// heap[3] = stack<BR>
/// <BR>ϡҸfindallnestƸƤӽФȤ<BR>
/// heap[1] -> heap[2]heap[2] -> heap[1]<BR>
/// ȸߤ˥ҡפưޤ<BR>

/// </TD>
/// <TD>

/// <TABLE BORDER=2 CELLPADDING=5>
/// <CAPTION>ڥȥ쥤</CAPTION>
/// <TR ALIGN=center> <TD>trail</TD><TD><NOBR></NOBR></TD> </TR>
/// </TABLE>
/// ȥ쥤ˤϡbacktrackκݤchoicepointޤ뤿ξäƤޤ

/// </TD>
/// </TR>
/// <TR VALIGN=top>
/// <TD>

/// <TABLE BORDER=2 CELLPADDING=5>
/// <CAPTION>ڥ</CAPTION>
/// <TR ALIGN=center> <TD>local</TD><TD><NOBR></NOBR></TD> </TR>
/// </TABLE>
/// ϽҸΰݻ뤿ΤΤǤ

/// </TD>
/// </TR>
/// </TABLE>
/// <BR><BR>
/// <TABLE BORDER=2 CELLPADDING=5>
/// <CAPTION>ڥ쥸</CAPTION>
/// <TR><TH>ά̾</TH><TH>쥸̾</TH><TH></TH><TH>ؤƤΰ</TH></TR>
/// <TR > <TD>HP</TD><TD> Heap Top Pointer</TD><TD>The heap pointer holds the top of the heap.</TD><TD>HEAP</TD> </TR>
/// <TR > <TD> HB</TD><TD> Heap Trail-Limit Pointer</TD><TD>The heap boundary pointer holds the boundary of the range on the heap where trailing are needed.<BR>ХåȥåɬפʾȤǤʤΤζؤ쥸</TD><TD>HEAP</TD> </TR>
/// <TR > <TD> HA</TD><TD> Heap Attention Pointer</TD><TD> The heap attention pointer indicates where the static unification code are pointed on.</TD><TD>HEAP</TD> </TR>
/// <TR > <TD> HU1</TD><TD> Unification Pointer 1</TD><TD>The heap unification pointer 1 indicates the place the type coercion code is focusing on, or the dynamic unification code is focusins on as one of the two feature structures.</TD><TD>HEAP</TD> </TR>
/// <TR > <TD> HU2</TD><TD> Unification Pointer 2</TD><TD>The heap unification pointer 2 indicates the place the dynamic unification code is focusing on as the other of the two feature structure.</TD><TD>HEAP</TD> </TR>
/// <TR > <TD> SP</TD><TD> Stack Pointer</TD><TD>The stack pointer holds the top of the stack.</TD><TD>STACK</TD> </TR>
/// <TR > <TD> FP</TD><TD> Frame Pointer</TD><TD> The frame pointer holds the addres of the current environment frame.<BR>
/// ߤAND-STACKؤޤ</TD><TD>STACK</TD> </TR>
/// <TR > <TD> RP</TD><TD> Register Top Pointer</TD><TD>The register pointer holds the top of the LOCAL registers.</TD><TD>LOCAL</TD> </TR>
/// <TR > <TD> TP</TD><TD> Trail Pointer</TD><TD>The trail pointer holds the top of the trail.</TD><TD>TRAIL</TD> </TR>
/// <TR > <TD> OP</TD><TD> Or-Stack Pointer</TD><TD> The choice-point-frame pointer holds the addres of the current choice point frame.<BR>
/// ߤOR-STACKؤޤ</TD><TD>STACK</TD> </TR>
/// <TR > <TD> B0</TD><TD> Cut Pointer</TD><TD> OPΣĲOR-STACKե졼ؤ쥸 <ref>cut_overview</ref> </TD><TD>STACK</TD> </TR>
/// <TR > <TD> IP</TD><TD> Instruction Pointer</TD><TD>The instruction pointer holds the next instruction address to execute.</TD><TD>CODE</TD> </TR>
/// <TR > <TD> CIP</TD><TD> Continuation Pointer</TD><TD> The continuation instruction pointer holds the next instruction addres when RETURN instruction is executed at the end of the clause.</TD><TD>CODE</TD> </TR>
/// <TR > <TD> UIP</TD><TD> Unification Return Pointer</TD><TD>The unification instruction pointer holds the next instruction address when PROCEED instruction is executed at the end of the type coercion/dynamic unification code.</TD><TD>CODE</TD> </TR>
/// </TABLE>

/// </p>
/// </desc>
/// <see></see>
/// <body>
class machine
{
	core heap[NHEAP];
	core local;
	core trail;
	Queue<core_p> queue;

	core_p HP;	// Heap Top Pointer

	core_p HB;	// Heap Trail-Limit Pointer
	core_p HA;	// Heap Attention Pointer
	core_p HU1;	// Unification Pointer 1
	core_p HU2;	// Unification Pointer 2
	core_p SP;  // Stack Pointer
	core_p FP;	// Frame Pointer
	core_p RP;	// Register Top Pointer
	core_p TP;	// Trail Pointer
	core_p OP;	// Or-Stack Pointer
	core_p B0;	// Cut Pointer
	code * IP;  // Instruction Pointer
	code * CIP;  // Continuation Pointer
	code * UIP;  // Unification Return Pointer
#ifdef LILFES_U
        core_p FA1;
        core_p FA2;
#endif // LILFES_U

//	cell *storep; core_p SHP;   // temporary
	typedef Pair<core_p, code *> ConstraintPair;
	Queue< ConstraintPair > ConstraintQueue;
	bool ConstraintEnabled;

	lexer_t	lexer;


public:
		machine();
		~machine();

// heap managing functions
	core_p SwitchNewHeap();
  /// ҸfindallƤ֤ȡSwitchNewHeapƤФ졢heap[1]ȤäƤ顢heap[2]ؤȰܤꡢheap[2]ȤƤheap[1]ؤȰưޤ
	void SwitchOldHeap(core_p old);
  /// ҸfindallλȡSwitchOldHeapƤФ졢heapؤȤɤޤ
	int GetCurrentSlot() { return GetSlot(HP); }
  /// HP(Heap Pointer)ؤslotޤ
	void ClearHeap(int slot);
  /// ҡפޤ
	void GoToHeap(int slot);
  /// HPؤƤ륹åȤƬΥ˼ʬȤؤcell֥ȤHP<var>slot</var>ƬΥؤ롣
//	int  StartNewHeap();		// return slot number
	void EndTheHeap() { EndTheHeap(GetSlot(HP)); }
	void EndTheHeap(int i);
  /// ߡȤƤޤ
  
  // TO DELETE core_p ReplaceFS(core_p fp);

/*	core_p ReplaceFSInternal(core_p fp);	*/
	void ClearStack() {
          SP = int2cp(STACK_BASE);
          FP = int2cp(0);
          OP = B0 = CORE_P_INVALID;
          TP = int2cp(0);
          HB = CORE_P_INVALID;
          queue.FlushAll();
        }
  /// åޤ
	core & GetHeap(int n) { return heap[n]; }
  /// heap<var>n</var>ܤ<ref>core</ref>֥Ȥޤ
	void SetHeap(int n, core &c) { heap[n].SetTo(c); }
  /// heap<var>n</var>ܤcore<var>c</var>򥻥åȤޤ
        void EnableConstraint(bool b) { ConstraintEnabled = b; }
  /// Constraint̵ͭ椷ޤ
        bool GetConstraintEnabled() { return ConstraintEnabled;}
  /// ConstraintͭɤĴ٤ޤ

// core manipulating functions
	void PutHeap(cell v) 	 { ASSERT(HP != CORE_P_INVALID); ASSERT(cp2int(GetOffset(HP)) < heap[GetSlot(HP)].GetSize()*sizeof(cell)); heap[GetSlot(HP)][GetOffset(HP)] = v; HP++; }
  /// λHPؤƤcell<var>v</var>졢HP򥤥󥯥Ȥޤ
		// !! PutHeap requires CheckHeapLimit
	cell ReadHeap(core_p hp) CALCF { ASSERT(hp != CORE_P_INVALID); return heap[GetSlot(hp)][GetOffset(hp)]; }
  /// core_p<var>hp</var>ؤcell֥Ȥޤ
	void WriteHeapDirect(core_p hp, cell c) { ASSERT(hp != CORE_P_INVALID); heap[GetSlot(hp)][GetOffset(hp)] = c; }
  /// core_p<var>hp</var>ؤˡcell<var>c</var>ޤ
	void WriteHeap(core_p hp, cell c);
  /// core_p<var>hp</var>ؤ꤬ȥ쥤뤬ɬפΰǤСtrailѹΥɥ쥹ͤ򤷤Ƥ顢<var>hp</var>ξcell<var>c</var>ޤ
        const cell& ref(core_p hp) const { return heap[GetSlot(hp)][GetOffset(hp)]; }
        cell& ref(core_p hp) { return heap[GetSlot(hp)][GetOffset(hp)]; }
  /// HPؤHEAPcellޤ
	cell ReadStack(core_p sp) { return STACK[GetOffset(sp)]; }
  /// åΡ<var>sp</var>ΥեåܤǤޤ
	void WriteStack(core_p sp, cell c) { STACK[GetOffset(sp)] = c; }
  /// åΡ<var>sp</var>ΥեåܤΥɥ쥹cell<var>c</var>Ǽޤ
	code *ReadStackIP(core_p sp);
  /// åäƤcodeޤ<BR>
  /// åǤǤcell4byteǤcode * 4byteΤΤ8byteΤΤ뤿ᡢ줾˱Ŭڤ˽뤿ᡢΤ褦ʥ᥽åɤѰդƤޤ
  
	void WriteStackIP(core_p sp, code *);
  /// åΡ<var>sp</var>ΥեåܤΥɥ쥹codeǼޤ
  /// åǤǤcell4byteǤcode * 4byteΤΤ8byteΤΤ뤿ᡢ줾˱Ŭڤ˽뤿ᡢΤ褦ʥ᥽åɤѰդƤޤ
	cell ReadLocal(int rp)
          /// <var>rp</var>ξ硧local<var>rp</var>ܤǤޤ<BR>
          /// <var>rp</var>ξ硧åե졼γ³ѿޤ<BR>
          /// <ref>varno</ref>򻲾ȡ
          {
            if( (int)cp2int(rp) >= 0 )  {
              /* ASSERT(cp2int(rp) < cp2int(RP)); */
              return local[rp];
            }
            else
              return ReadStack(int2cp(cp2int(FP) - cp2int(rp))+(SF_LOCAL_OFFSET-1));
          }

  
	void WriteLocal(core_p rp, cell c) 
          {
            if( (int)cp2int(rp) >= 0 ) {
              /* ASSERT(cp2int(rp) < cp2int(RP)); */
              local[rp] = c;
            }
            else WriteStack(int2cp(cp2int(FP) - cp2int(rp))+(SF_LOCAL_OFFSET-1), c);
          }
  /// <var>rp</var>ξ硧local<var>rp</var>ܤǤcell<var>c</var>Ǽޤ<BR>
  /// <var>rp</var>ξ硧åե졼γ³ѿѤΥեɤcell<var>c</var>Ǽޤ<BR>
  /// <ref>varno</ref>򻲾ȡ
#ifdef COREP_PTR
	void WriteLocal(int rp, cell c)
		{ if(        rp  >= 0 ) { /* ASSERT(rp < cp2int(RP)); */ local[rp] = c; } else WriteStack(FP - rp +(SF_LOCAL_OFFSET-1), c); }
#endif
	cell ReadTrail(core_p tp) { return trail[tp]; }
  /// TRAIL<var>tp</var>ܤǤޤ

// limit checking functions
	void CheckStackLimit(core_p sp)
	{
		if( cp2int(GetOffset(sp)) >= STACK.GetSize() ) {
			if( USE_MULTIPLY )
				{ STACK.Resize( STACK.GetSize()*3/2 ); }  
			else
				{ STACK.Resize( STACK.GetSize()+ALLOC_STEP ); }  
		}
	}
  /// <var>sp</var>ؤ꤬STACKˤƤϰϳʤСSTACKĥޤ褦ˤޤ
	void CheckTrailLimit(core_p tp)
	{
		if( cp2int(tp) >= trail.GetSize() ) {
			if( USE_MULTIPLY )
				{ trail.Resize( trail.GetSize()*3/2 ); }  
			else
				{ trail.Resize( trail.GetSize()+ALLOC_STEP ); }  
		}
	}
  /// <var>tp</var>trailΥ礭Сtrailĥޤ
  
	void CheckHeapLimit(core_p hp)
	{
          while( cp2int(GetOffset(hp)) >= heap[GetSlot(hp)].GetSize() ) {
			if( USE_MULTIPLY )
	            heap[GetSlot(hp)].Resize( heap[GetSlot(hp)].GetSize()*3/2 );/// 1.5ܤ
			else
	            heap[GetSlot(hp)].Resize( heap[GetSlot(hp)].GetSize()+ALLOC_STEP );
          }
	}
  /// <var>hp</var>ؤ꤬ΰ賰äʤslotcellǿ­ʤСˡΰĥƼޤ褦ˤޤ
  
// local-stack manipulating functions
	void Push(cell c) { local[RP++] = c; }
  /// RPؤlocalξcell<var>c</var>ǼRP򥤥󥯥Ȥޤ
	void PushIP(code *);
  /// äƤcodeФơPush¹Ԥޤ<BR>
  /// ǤǤcell4byteǤcode * 4byteΤΤ8byteΤΤ뤿ᡢ줾˱Ŭڤ˽뤿ᡢΤ褦ʥ᥽åɤѰդƤޤ
	cell Pop()        { return local[--RP]; }
  /// RPؤlocalξ꤫Ǥ1ļRPǥȤޤ
	code * PopIP();
  /// äƤcodeФơPop¹Ԥޤ<BR>
  /// ǤǤcell4byteǤcode * 4byteΤΤ8byteΤΤ뤿ᡢ줾˱Ŭڤ˽뤿ᡢΤ褦ʥ᥽åɤѰդƤޤ
  
// Internal register set functions
	code * GetCIP() { return CIP; }
  /// 쥸 CIP ޤ
	code * GetIP() { return IP; }
  /// 쥸IP ޤ
	core_p GetTP() { return TP; }
  /// 쥸TP ޤ
	core_p GetSP() { return SP; }
  /// 쥸SP ޤ
	core_p GetRP() { return RP; }
  /// 쥸RP ޤ
	core_p GetHP() CONSTF { return HP; }
  /// 쥸HP ޤ
	core_p GetHA() CONSTF { return HA; }
  /// 쥸HA ޤ
	core_p GetHU1() CONSTF { return HU1; }
  /// 쥸HU1 ޤ
	core_p GetHU2() CONSTF { return HU2; }
  /// 쥸HU2 ޤ
#ifdef LILFES_U
        core_p GetFA1() CONSTF { return FA1; }
  /// FA1ޤ
  /// FA1Ȥϡñ첽ԤȤˡȲñ첽褦ȤƤΤξǤ
        core_p GetFA2() CONSTF { return FA2; }
  /// FA2ޤ
  /// FA2Ȥϡñ첽ԤȤˡȲñ첽褦ȤƤΤ⤦ξǤ
#endif // LILFES_U
	void SetUIP(code * x) { UIP = x; }
  /// 쥸 UIP <var>x</var>ޤ
	void SetIP(code * x) { IP = x; }
  /// 쥸 IP <var>x</var>ޤ
	void SetRP(int x) { RP = (core_p)0 + x; }
  /// 쥸 RP <var>x</var>ޤ
	void SetHP(core_p x) { HP = x; }
  /// 쥸 HP <var>x</var>ޤ
	void SetHA(core_p x) { HA = x; }
  /// 쥸 HA <var>x</var>ޤ
	void SetHU1(core_p x) { HU1 = x; }
  /// 쥸 HU1 <var>x</var>ޤ
	void SetHU2(core_p x) { HU2 = x; }
  /// 쥸 HU2 <var>x</var>ޤ

  // TO DELETE	outform FormatStructure(core_p addr);
  // TO DELETE	outform FormatStructure(core_p addr, core_p *share, int *sharecnt, size_t nshare);
  // TO DELETE	void DetectSharedStructure(core_p addr, core_p *share, int *sharecnt, size_t &nshare);
  // TO DELETE	void MakeShareArray(core_p *, int *, size_t, core_p *&, int *&, size_t &);

	// Kairyoable
	core_p Deref(core_p addr) { P5("machine::Deref"); return deref(addr); }
  /// deref()ƱǤ
#if 0
	core_p deref(core_p addr) { P5("machine::deref"); return IsPTR(ReadHeap(addr)) ? deref(c2PTR(ReadHeap(addr))) : addr; }
#else
        core_p deref(core_p addr) {
          P5("machine::deref");
          cell tmp;
          while(IsPTR(tmp = ReadHeap(addr)))
            addr = c2PTR(tmp);
          return addr;
        }
  /// core_p<var>addr</var>ؤcellPTRդcell򤿤ɤäƤäơǽŪ˻ؤƤPTRʳΥcellؤΥݥ󥿤֤ޤ
#endif
	cell DerefCell(cell c) { P5("machine::DerefCell"); return derefCell(c); }
  /// derefCell()ƱǤ
	cell derefCell(cell c) { P5("machine::derefCell"); return IsPTR(c) ? derefCell(ReadHeap(c2PTR(c))) : c; }
  /// cell<var>c</var>PTRդΥ򤿤ɤäƤäơǽŪ˻ؤƤPTRʳΥcellޤ

// High-level Core Manipulating Function
#ifdef TRAIL
	core_p SetTrailPoint(code *retp);		// Set a choice point frame and return the address
  /// choice frame1ĺޤ<var>retp</var>ˤϼԤȤꤷޤ
	core_p SetTrailPoint() { return SetTrailPoint(IP); }
  /// SetTrailPoint(IP)¹Ԥޤ
	void TrailAgain(core_p cp, code *retp);				// 
	void TrailAgain(core_p cp) { TrailAgain(cp, IP); }
	void TrailAgain(code *retp) { TrailAgain(OP, retp); }
	void TrailAgain() { TrailAgain(OP, IP); }
  /// ΤȤchoice frameϤ񤭴choice frameˤȤäƤ򸵤ˡtrailξ֤ᤷޤ
	void TrailBack(core_p cp);				// 
	void TrailBack() { TrailBack(OP); }		//
  /// Ǹ褬äȤˡΥ᥽åɤƤФ졢choice frameơϤޤ
	void SetLevel() { B0 = OP; }
  /// Cut塢OPɤ˻äƤϿƤޤ<BR>
  /// (OPB0򤷤Ƥޤ)
  
	core_p GetCutPoint() { return OP; }
  /// OP
	void   DoCut(core_p cp);
  /// ʣʸҸ˴ؤơä̤ʸɬפ̵ȤˤΥ᥽åɤƤФޤ
  /// OPλؤ򡢤ޤ㤤ؤchoice frameˤޤ
#endif

// executing functions
	bool Execute(code * cp);
  /// <var>cp</var>IPExecLoop()ƤӤޤ
	void DisplayStatistics();
  /// ΰ HEAP,STACK,TRAIL줾쥻򤤤ĻѤƤ뤫ɽޤ
	bool NextAnswer() { Fail(); if( IP != 0 ) ExecLoop(); return (HA != CORE_P_INVALID); }
  ///  ';'줿ȤˡβõޤȤFail()Ǥ
protected:
	void ExecLoop();
  /// codelist¹ԤޤcodeǼºݤ˹Ԥ񤤤Ƥޤ
  /// Execute(),Unify(),NextAnswer()ǻѡ

// State-Setting
public:
	void Fail();
  /// ñ첽ԤȤν򤷤ޤ
  /// OPؤƤ(choice frame)Ĵ١IPưޤ
	void Proceed();
  /// unify queueñ첽٤ȤĤäƤФȤBeginUnify(),ʤUIPؤ˽Фޤ
   
// Functions below this line is internal
protected:
	
// Code reading functions
	code GetCode() { return *(IP++); }
   /// IP(Instruction Pointer)ؤcodeIP򥤥󥯥Ȥޤ
	const type *GetType()       { const type *ret = lilfes::GetType(IP); IP+=CODE_TYPE_SIZE; return ret; }
  /// IPؤˤ뷿ʬIPʤޤ
	const feature *GetFeature() { const feature *ret = lilfes::GetFeature(IP); IP+=CODE_FEATURE_SIZE; return ret; }
  /// IPؤˤʬIPʤޤ
	tserial GetTypeSN()         { tserial ret = lilfes::GetTypeSN(IP); IP+=CODE_TYPE_SIZE; return ret; }
  /// IPؤˤ뷿ΥꥢֹʬIPʤޤ
	fserial GetFeatureSN()      { fserial ret = lilfes::GetFeatureSN(IP); IP+=CODE_FEATURE_SIZE; return ret; }
  /// IPؤˤΥꥢֹʬIPʤޤ
	code *GetInstP()            { code * ret = lilfes::GetInstP(IP); IP+=CODE_INSTP_SIZE; return ret; }
  /// IPؤˤcodeʬIPʤޤ
//	short GetShort()            { short ret = lilfes::GetShort(IP); IP+=CODE_SHORT_SIZE; return ret; }
	pserial GetProcSN()         { pserial ret = lilfes::GetProcSN(IP); IP+=CODE_PROC_SIZE; return ret; }
  /// IPؤˤҸΥꥢֹʬIPʤޤ
	varno GetVarNo()            { varno ret = lilfes::GetVarNo(IP); IP+=CODE_VARNO_SIZE; return ret; }
  /// IPؤˤѿֹʬIPʤޤ
	int32 GetRelJump()          { int32 ret = lilfes::GetRelJump(IP); IP+=CODE_RELJUMP_SIZE; return ret; }
  /// IPؤˤRelJump(codeа֡ư)ʬIPʤޤ
	int16 GetInt16()            { int16 ret = lilfes::GetInt16(IP); IP+=CODE_INT16_SIZE; return ret; }
  /// IPؤˤ16bitʬIPʤޤ
	cell GetCell()              { cell ret = lilfes::GetCell(IP); IP+=CODE_CELL_SIZE; return ret; }
  /// IPؤˤcellʬIPʤޤ
	mint GetMInt()              { mint ret = lilfes::GetMInt(IP); IP+=CODE_MINT_SIZE; return ret; }
  /// IPؤˤmintʬIPʤޤ
	mfloat GetMFloat()          { mfloat ret = lilfes::GetMFloat(IP); IP+=CODE_MFLOAT_SIZE; return ret; }
  /// IPؤˤmfloatʬIPʤޤ
	mchar GetMChar()            { mchar ret = lilfes::GetMChar(IP); IP+=CODE_MCHAR_SIZE; return ret; }
  /// IPؤˤmcharʬIPʤޤ
	sserial GetStringSN()       { sserial ret = lilfes::GetStringSN(IP); IP+=CODE_STRING_SIZE; return ret; }
  /// IPؤˤʸΥꥢֹʬIPʤޤ
  
// unification functions
public:	void BeginUnify();
  /// ñ첽2Ĥη˱ơ¹Ԥ٤codelistؤ褦IP򥻥åȤޤ
  /// ( Proceed(),Unify(),ExecLoop()ǻѡ)
protected:
	void GetUnifyQueue(core_p &u1, core_p &u2);
  /// unify queueñ첽٤<var>u1</var>,<var>u2</var>ޤ
	void PutUnifyQueue(core_p u1, core_p u2);
  /// <var>u1</var>,<var>u2</var>unify queueɲäޤ
	void PutUnifyQueueType(core_p u1, tserial u2);
  /// <var>u1</var>,<var>u2</var>unify queueɲäޤ
  
// imaginary and default unification
protected:    
    struct hash_core_p
      /// No Comment
      {
        size_t operator()(core_p __x) const { return __x; }
      };

    typedef __gnu_cxx::hash_map< core_p, bool, hash_core_p > core_p_hash;
  /// No Comment
    struct hash_core_p_pair
      /// No Comment
      {
        size_t operator()(std::pair<core_p, core_p> __x) const { return (__x.first << 1) ^ __x.second; }
      };
    typedef __gnu_cxx::hash_map<std::pair<core_p, core_p>, bool, hash_core_p_pair > cpcp_hash;
  /// No Comment
    typedef __gnu_cxx::hash_map<core_p, int, hash_core_p > cp2int_hash;
  /// No Comment

    void ImaginaryUnify_STR(core_p p1, core_p p2);
    void ImaginaryUnify_VAR__STR_(core_p p1, core_p p2);
    void ImaginaryUnify_STR__STR_(core_p p1, core_p p2, std::vector<std::pair<core_p, core_p> > &queue);
    void ImaginaryUnify_STRT_STR_(core_p p1, core_p p2, std::vector<std::pair<core_p, core_p> > &queue);
    void ImaginaryUnify_STR__STRT(core_p p1, core_p p2, std::vector<std::pair<core_p, core_p> > &queue);
    void ImaginaryUnify_STRT_STRT(core_p p1, core_p p2, std::vector<std::pair<core_p, core_p> > &queue);
    void ImaginaryDetectStructureSharing(core_p p, std::vector<core_p> &mark, std::vector<core_p> &ss);
    outform __ImaginaryDisplayAVM(core_p p, std::vector<core_p> &mark, std::vector<core_p> &ss);
    void ImaginaryFailPoint(core_p p, core_p_hash &mark, core_p_hash &failpath, core_p_hash &failpoint, std::vector<core_p> stack);
//    void __FollowDefault(FSP x1, FSP x2, core_p_hash &failpath2, core_p_hash & failpoint2, std::vector<core_p> &stack);
    void __GeneralizeDefault(core_p p1, core_p p2, core_p_hash &failpath2, core_p_hash & failpoint2, std::vector<core_p> &stack);
    void __DefaultCost(core_p p, int &cost, std::vector<core_p> &stack, int coef);
    void DefaultCost(core_p p1, core_p p2, int &cost, cpcp_hash &mark, cp2int_hash &sscnt, std::vector<core_p> &stack);
  /// No Comment
public:
//    void __HeapDisplay(core_p p, core_p_hash& mark);
//    void HeapDisplay(core_p p);
    bool ImaginaryUnify(core_p p1, core_p p2);
  /// p1p2forced unification(botȤȿФtopĤޤƤηΥ֥פȤʤ뷿ƳФfailʤ褦ˤñ첽)ޤ
  
    outform ImaginaryDisplayAVM(core_p p);
  /// forced unification(ImaginaryUnify򻲾)η̤ɽޤ
    bool DefaultUnify(FSP s1, FSP d1, FSP e, FSP r, int &cost);
    void __DefaultUnify(core_p p2, core_p p3, core_p_hash &failpath2, core_p_hash & failpoint2, std::vector<core_p> &stack);
    bool DefaultUnify(FSP s1, FSP d1, FSP r, int &cost);

    void markSSonFailPath(core_p, core_p_hash&, core_p_hash&, core_p_hash&);
    core_p __DefaultUnify(core_p, core_p_hash &, core_p_hash &, core_p_hash &, std::vector<core_p> &);
    bool DefaultUnify(FSP s1, FSP d1);
    
#ifdef XCONSTR
	void ExpandStructure(tserial result);
  /// ά(VAR)ǳǼƤ¤Ȥη(STR)Ÿޤ
#endif

public:
	void DefaultCall(code *cl, int ar);
  /// <var>cl</var>IPޤ<BR>
  /// <var>ar</var>ο<BR>
// basic manipulating instruction (obsolete)
	core_p AllocNew(cell c) { core_p ret = HP; CheckHeapLimit(ret+1); PutHeap(c); return ret; }
  /// cell<var>c</var>HPؤƤ륢ɥ쥹˳Ǽޤΰ褬­ƤСݤǳǼޤ֤ͤȤơǼΥɥ쥹֤ޤ
	core_p AllocNew() { return AllocNew(VAR2c(bot)); }
  /// AllocNew(cell c)ˤơcell<var>c</var>ˡbotΥǡݻ륻ꤷΤ¹Ԥޤ
	core_p FollowFeature(core_p p, const feature *f);
  /// core_p<var>p</var>ξ¤<var>f</var>򤿤ɤä¤ޤ<BR>
  /// ɬפʤСά(VAR)Ȥη(STR)ᤷꡢcoerce⤷ꤷޤ
	bool   CoerceType(core_p p, const type *t);
  /// <var>p</var>ؤɥ쥹ˤ뷿type<var>t</var>Ѵޤ
	bool   Unify(core_p p1, core_p p2);
  /// <var>p1</var><var>p2</var>ؤɥ쥹ˤ¤ñ첽Ԥޤ
  
    bool DefaultUnify(core_p p1, core_p p2);
  /// ʤñ첽Ԥ¤ƱΤդñ첽ޤ<var>p1</var><var></var>
    bool ForceUnify(core_p p1, core_p p2);
  /// No Comment

// Interpret function (temporary)
//	codelist * Interpret(core_p p);
	codelist * Interpret_internal(core_p lst);
  /// Interpret()ǺƵŪ˸ƤӽФʬǤ
	codelist * Interpret(FSP f);
  /// ¤<var>f</var>ɽ줿Ҹ¹Ԥ륳ɤޤ


	void Interrupt();
  /// Ctrl-C줿Ȥˡ򸵤ᤷޤ

// Debugging function
public:
//	const core &GetHeap() { return heap; }
	void TraceOutput(int tt, const type *t, int x);
  /// Traceξɽޤ<BR>
  /// <var>tt</var>trace<BR>
  /// <var>t</var>Ҹ̾<BR>
  /// <var>x</var>ο<BR>
	void Dump();
  /// heapȤɽޤ

	lexer_t getLexer() { return lexer; }
	void setLexer(lexer_t l) { lexer = l; }

	void parse(lexer_t l);
	void parse();
  /// <var>l</var> ʸɤ߹߼¹Ԥޤ
	FSP eval(const char *s);
  /// <var>l</var> ʸɤ߹ߡlist 򤢤魯 FSP Ȥ֤ޤ
	bool call(FSP f);
  /// <var>f</var> ¹Ԥޤ true ֤ޤ
	  
};
/// </body></classdef>

//inline	void machine::Push(cell c) { stack[SP++] = c; }
//inline	cell machine::PopDirect()  { return stack[--SP]; }

#if SIZEOF_INT == SIZEOF_INTP
// inline void machine::WriteStackIP(core_p sp, code *cp)
// 			{ WriteStack(sp, FORCE_CAST(cell, cp)); }
inline void machine::WriteStackIP(core_p sp, code *cp)
			{ WriteStack(sp, static_cast<cell>(FORCE_CAST(int, cp))); }
inline code *machine::ReadStackIP(core_p sp)
			{ cell c = ReadStack(sp); return FORCE_CAST( code *, c ); }

inline void machine::PushIP(code *cp)
			{ Push(static_cast<cell>(FORCE_CAST(int, cp))); }
inline code *machine::PopIP()
			{ cell c = Pop(); return FORCE_CAST( code *, c ); }

#elif SIZEOF_INT * 2 == SIZEOF_INTP
inline void machine::WriteStackIP(core_p sp, code *cp)
{ 
	WriteStack( sp  , int2cell(FORCE_CAST(ptr_int, cp)) ); 
	WriteStack( sp+1, int2cell(FORCE_CAST(ptr_int, cp)>>(sizeof(cell)*8)) ); 
}

inline code *machine::ReadStackIP(core_p sp)
{ 
	return FORCE_CAST(code *, 
		((ptr_int)cell2int(ReadStack(sp+1))<<(sizeof(cell)*8))
		         +cell2int(ReadStack(sp  ))); 
}

inline void machine::PushIP(code *cp)
{ 
	Push( int2cell(FORCE_CAST(ptr_int, cp)) ); 
	Push( int2cell(FORCE_CAST(ptr_int, cp)>>(sizeof(cell)*8)) ); 
}
inline code *machine::PopIP()
{
	cell c1 = Pop();
	cell c2 = Pop();
	return FORCE_CAST(code *, 
		((ptr_int)cell2int(c1)<<(sizeof(cell)*8))
		         +cell2int(c2)); 
}

#else
#error size of code* is bad!!
#endif

inline void machine::DefaultCall(code *cl, int ar)
{
	RP = (core_p)0+ar;
	IP = cl;
}

//////////////////////////////////////////////////////////////////////////////
// STRUCTURE_MAXSIZE defines the maximum number of cells of a feature structure
// for detecting shared structure (consequently, displaying and inputting)

#define STRUCTURE_MAXSIZE 8192

#ifdef INLINE_WRITEHEAP
inline void machine::WriteHeap(core_p hp, cell c)
{
	P5("machine::WriteHeap");

	if( GetSlot(hp) != GetSlot(HB) || hp < HB )
	{
		CheckTrailLimit(TP+2);
		trail[TP++] = PTR2c(hp);
		trail[TP++] = ReadHeap(hp);
	}
	WriteHeapDirect(hp, c);
}
#endif


#ifdef PROF_UNIFY
extern profuser *unifprof;

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> StartUnifProf </name>
/// <overview> ñ첽Υץե򳫻Ϥޤ </overview>
/// <desc>
/// <jpn>
/// <p>
/// ñ첽Υץեʼ¹Ի֤η¬ˤ򳫻Ϥޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <args> ̵</args>
/// <retval> ̵ </retval>
/// <remark></remark>
/// <see>StopUnifProf</see>
/// <body>
inline void StartUnifProf() { profiler::DisableProfiling(); if( unifprof ) ABORT("Double prof"); unifprof = new profuser("Dynamic Unification"); profiler::EnableProfiling();}
/// </body></funcdef>

/////////////////////////////////////////////////////////////////////////
/// <funcdef>
/// <name> StopUnifProf </name>
/// <overview> ñ첽Υץեߤޤ</overview>
/// <desc>
/// <jpn>
/// <p>
/// ñ첽Υץեߤޤ
/// </p>
/// </jpn>
/// <eng>
/// <p>
/// not yet
/// </p>
/// </eng>
/// </desc>
/// <args> ̵</args>
/// <retval> ̵ </retval>
/// <remark></remark>
/// <see>StartUnifProf</see>
/// <body>
inline void StopUnifProf() { profiler::DisableProfiling(); if( unifprof== NULL ) { /*ABORT("No prof");*/} else delete unifprof;  unifprof = NULL; profiler::EnableProfiling(); }
/// </body></funcdef>

#else
inline void StartUnifProf() { }
inline void StopUnifProf() { }
#endif

} // namespace lilfes

#endif // __machine_h
