/* $Id: proc.h,v 1.2 2004/02/08 06:35:52 mak Exp $
 *
 *    Copyright (c) 1997, Makino Takaki
 *
 *    You may distribute this file under the terms of the Artistic License.
 *
 */

///  <ID>$Id: proc.h,v 1.2 2004/02/08 06:35:52 mak Exp $</ID>
//
///  <COLLECTION> lilfes-bytecode </COLLECTION>
//
///  <name>proc.h</name>
//
///  <overview>
///  <jpn>Ҹ򰷤Υ롼</jpn>
///  <eng>??? </eng>
///  </overview>
/// <see>proc.cpp</see>

/// <notiondef>
///
/// <name> indexing_overview </name>
/// <title> indexing </title>
/// 
/// <desc>
/// indexingȤϹ®ˡΣǤҸ1ˤä̵̤ʥɤμ¹Ԥʤơ®ˤޤ
/// <p> </p>
/// </desc>
/// <see>  </see>
/// </notiondef>

#ifndef __proc_h
#define __proc_h

#include "lconfig.h"
#include <string.h>
#include "hash.h"
#include "code.h"
#include "lstring.h"

namespace lilfes {

////////////////////////////////////////
/// <classdef>
/// <name> proc_t </name>
/// <overview> ƽҸ줬ǸƤФ줿Ȥ˼¹Ԥ٤ξݻ륯饹</overview>
/// <desc>
/// <p>
/// Ҹ줬ƤФ򤷤Ȥ˲򤹤٤ξäƤޤ
/// Ҹ1Ĥ1Ĥproc_t֥Ȥбޤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
struct proc_t
{
	code *cl;
  /// ѥ뤷֥
	const type *tt;
  /// 1ηǤ
	mint ti;
  /// 1mintλͤǤ
	sserial ts;
  /// 1ʸΤȤΤʸΥꥢֹǤ
	bool instant;
  /// 1Ǥ뤫󥹥󥹤Ǥ뤫<br>
  /// 㤨ФҸpredäȤơpred(int)ȸƤФ줿Ȥfalseˤʤꡢpred(10)ȸƤФ줿Ȥtrueˤʤޤ
};
/// </body></classdef>

class procedure;
class procthunk;

////////////////////////////////////////
/// <classdef>
/// <name> procpair </name>
/// <overview> procedureбprocthunkȤˤ饹</overview>
/// <desc>
/// <p>
/// procedureбprocthunkȤˤưΥ饹Ǥ
/// </p>
/// </desc>
/// <see></see>
/// <body>
struct procpair
{
	procedure *pc;
	procthunk *pt;
  /// procedure<var>pc</var>бprocthuk֥ȤǤ
};
/// </body></classdef>

////////////////////////////////////////
/// <classdef>
/// <name> procthunk </name>
/// <overview> thunk饹</overview>
/// <desc>
/// <p>
/// procedure ҸʬΩΤǤ
/// indexingȤäȤ߹߽Ҹäꤹ뤿Υ饹Ǥ
/// Υ饹ݥ饹ǡΥ饹Υ󥹥󥹤뤳ȤϤǤޤ
/// <ref>indexing_overview</ref>
/// </p>
/// </desc>
/// <see></see>
/// <body>
class procthunk
{
protected:
	uint arity;
  /// ο
public:
	procthunk(uint ar) { arity = ar;}
  /// <var>ar</var>ο<br>
	virtual ~procthunk() {}
	virtual void execwork(machine &m) = 0;
  /// ºݤ˽Ԥޤ貾۴ؿǡºݤνϥ֥饹Ǻޤ
	virtual bool NeedNewTypeRevise() { return false; }
  /// 줿Ȥ˾ɬפɤɽޤ
	void procthunk::exec(machine &m) { execwork(m); }
  /// execwork()ƤӤޤ
	static const char *className;
  /// Υ֥ȤΥ饹̾Ǥ
	virtual const char *ClassName() { return className; }
  /// Υ֥ȤΥ饹̾ޤ
};
/// </body></classdef>

////////////////////////////////////////
/// <classdef>
/// <name> procedure </name>
/// <overview> Ҹ쥯饹</overview>
/// <desc>
/// <p>
/// ҸΥ饹Ǥ<br>
/// ĤνҸϡĤprocthunk֥Ȥʣproc_t֥Ȥޤ<br>
/// Ĥproc_tĤϡLiLFeSץǤΤνҸθƤФΤ裱ΰۤʤΤĤ뤫Ƿޤޤ<br>
/// proc_tΤȤCodelistȤƤӤޤ()᥽åAddCodelist()
/// </p>
/// </desc>
/// <see></see>
/// <body>
class procedure
{
	const type *reptype;
	VarArray<proc_t> cls;
	code *cl;   /// ѥΥ
	uint arity;  /// ο
	uint serialno;
	bool trace;
  /// LiLFeSΥǥХåǽǤνҸtrace뤫ɤɽޤ
	bool special;
	bool multifile;
	bool dynamic;

	static VarArray<procpair> serialtable;
        static IntegerHash<procedure> hash; /// key = procedurereptypetserial  value = procedure

protected:
	void SetThunk(procthunk *);
  /// procedureбprocthunk֥Ȥꤷޤ
	code *MakeCaller(uint ncls, Bitmap *clx, bool trace, code *failCode, const type * tracetype);
  /// <var>ncls</var>clauseο(Bitmap<var>clx</var>Ĺ)<br>
  /// <var>clx</var><br>
  /// <var>trace</var>LiLFeSΥǥХåǽȤɤʥǥХåʤ餽νҸƤӽФɤˤ뤫ɤ<br>
  /// <var>failCode</var>ԤȤɤ˹Ԥξ<br>
  /// <var>tracetype</var>traceμ<BR><BR>
  /// ɤ¹Ԥ뤫ξäɤޤ<BR>
  /// 㤨нҸPꡢPޤ⤬(ᣱᣵ)äȤޤ
  /// <TABLE BORDER=2 CELLPADDING=3>
  /// <TR> <TD>ᣱ</TD><TD>P(String):- .</TD> </TR>
  /// <TR> <TD>ᣲ</TD><TD>P(""):- ߡ.</TD> </TR>
  /// <TR> <TD>ᣳ</TD><TD>P(""):- ߡ.</TD> </TR>
  /// <TR> <TD>ᣴ</TD><TD>P(""):- .</TD> </TR>
  /// <TR> <TD>ᣵ</TD><TD>P(""):- .</TD> </TR>
  /// </TABLE>
  /// ᣱᣳᣴ˸Ƥ֤褦ʥɤ硢Ȥ"10110"ȤBitmap֥ȤϤȡ
  /// <TABLE BORDER=2 CELLPADDING=3>
  /// <TR><TD>
  /// ᣱƤ<BR>
  /// ᣳƤ<BR>
  /// ᣴƤ<BR>
  /// </TD></TR>
  /// </TABLE>
  /// Ȥɤޤ
public:
	procedure(const type *rept, uint arity);
  /// <var>rept</var>ɽ<br>
  /// <var>arity</var>ο<br>
	virtual ~procedure();
		
	tserial GetKey() const { return reptype->GetSerialNo(); } // for hashtable...
  /// ϥåѤΥ᥽åɤǤȤƤνҸɽפΥꥢֹޤ
	const char *GetName() const { return reptype->GetName(); }
  /// νҸɽפ̾ޤ
	uint GetArity() const { return arity; }
  /// οޤ
	uint GetSerialNo() const { return serialno; }
  /// ꥢֹޤ
	procthunk* GetThunk() { return SerialThunk(serialno); }
  /// procedureбprocthunk֥Ȥޤ
	void SetMultifile(bool flg = true) { multifile = flg; }
  /// proceduremultifileʣΥեǽ⤿ˤˤޤ 
	void SetDynamic(bool flg = true) { dynamic = flg; }
  /// proceduredynamicʥ桼ưŪѹǤ褦ˡˤˤޤ 

	bool Call(machine &m);
  /// C椫ҸƤ֤Ȥ˻Ȥޤ<BR>
  /// ˡӡʽҸfatherξ<BR>
  /// LiLFeSץǸƤ֤Ȥfather()<BR>
  /// CǸƤ֤Ȥfather.Call()<BR>
	bool Call(machine &m, FSP arg1);
  /// 
	bool Call(machine &m, FSP arg1, FSP arg2);
  /// 
	bool Call(machine &m, FSP arg1, FSP arg2, FSP arg3);
  /// 
	bool Call(machine &m, FSP arg1, FSP arg2, FSP arg3, FSP arg4);
  /// 
	bool Call(machine &m, FSP arg1, FSP arg2, FSP arg3, FSP arg4, FSP arg5);
  /// 
	bool Call(machine &m, FSP arg1, FSP arg2, FSP arg3, FSP arg4, FSP arg5, FSP arg6);
  /// 
	bool Call(machine &m, FSP args[ /*arity*/ ]);
  /// 

	void SetSpecialThunk(procthunk *p);
  /// νҸspecialˤprocthunk<var>p</var>򤽤νҸprocthunkˤޤ
	void ClearSpecialThunk();
  /// νҸspecialfalseˤprocthunk򤹤(proc_selectthunk)ˤޤ
	virtual void AddCodelist(code *c, const type *toptype = NULL);
  /// code<var>c</var>ꥹȤɲäޤθɲäޤ
	virtual void AddCodelistINT(code *c, const type *toptype, mint i);
  /// 裱Υ󥹥󥹤ξΡcode<var>c</var>ꥹȤɲäޤmint<var>i</var>ˤϤͤޤθɲäޤ
	virtual void AddCodelistSTG(code *c, const type *toptype, sserial ss);
  /// 裱ʸ󷿤Υ󥹥󥹤ξΡcode<var>c</var>ꥹȤɲäޤsserial<var>ss</var>ˤϤʸΥꥢֹ椬ޤθɲäޤ
	virtual void AddCodelistTop(code *c, const type *toptype = NULL);
  /// code<var>c</var>ꥹȤɲäޤƬɲäޤ
	virtual void AddCodelistTopINT(code *c, const type *toptype, mint i);
    /// 裱Υ󥹥󥹤ξΡcode<var>c</var>ꥹȤɲäޤmint<var>i</var>ˤϤͤޤƬɲäޤ
	virtual void AddCodelistTopSTG(code *c, const type *toptype, sserial ss);
  /// 裱ʸ󷿷Υ󥹥󥹤ξΡcode<var>c</var>ꥹȤɲäޤsserial<var>ss</var>ˤϤʸΥꥢֹ椬ޤƬɲäޤ
	virtual void SetTrace(bool tr);
  /// νҸΥǥХå򤹤뤫ɤꤷޤ
	void Compile();
  /// <ref>indexing_overview</ref>˴ؤ򤷡Ŭڤprocthunk򥻥åȤޤ
	static procedure* New(const type *n, uint arity);
  /// ɽפ<var>n</var>ο<var>arity</var>νҸޤǤƱΤ¸ߤФνҸ֤ǤʤХ󥹥ȥ饯¹Ԥޤ
	static procedure* New(const type *n, uint arity, procthunk *thunk);
  /// ɽפ<var>n</var>ο<var>arity</var>procthunk<var>thunk</var>νҸޤ
	static procedure* Search(const type *t) 
			{ procedure *r = hash.Find(t->GetSerialNo()); return r; }
  /// <var>t</var>ɽפȤprocedure֥Ȥޤ
        static procedure* Serial(uint serial) { return serialtable[serial].pc; }
  /// ꥢֹ椫бprocedure֥Ȥޤ
	static procthunk* SerialThunk(uint serial) { return serialtable[serial].pt; }
 /// ꥢֹ椫бprocthunk֥Ȥޤ
	static procedure* SearchByThunk(procthunk *pt);
  /// procthunk<var>pt</var>бprocedure֥Ȥޤ
	static uint GetSerialCount() { return serialtable.GetSize(); }
  /// ĤΥꥢֹ椬Ƥ뤫Ĵ٤ޤ
	static void NewTypeNotify();
  /// ɲäȤΥ᥽åɤ¹Ԥ졢NeedNewTypeRevise()true֤procthunkĽҸˤĤơprocthunkѤproc_selectthunkˤޤ
	static void terminate();
  /// λǤޤ
};
/// </body></classdef>

////////////////////////////////////////
/// <classdef>
/// <name> proc_builtin </name>
/// <overview> Ȥ߹߽Ҹ쥯饹</overview>
/// <desc>
/// <p>
/// Ȥ߹ߤνҸò procedure Ǥ桼ȤǤʤ褦ˤƤޤ
/// </p>
/// </desc>
/// <see></see>
/// <body>
class proc_builtin : public procedure
{
public:
	proc_builtin(const type *name, uint arity, procthunk *thunk);
  /// <var>name</var>ɽ<br>
  /// <var>arity</var>ο<br>
  /// <var>thunk</var>бprocthunk<br>
	virtual void AddCodelist(code *c, const type *toptype = NULL);
	virtual void AddCodelistINT(code *c, const type *toptype, mint i);
	virtual void AddCodelistSTG(code *c, const type *toptype, sserial ss);
	virtual void AddCodelistTop(code *c, const type *toptype = NULL);
	virtual void AddCodelistTopINT(code *c, const type *toptype, mint i);
	virtual void AddCodelistTopSTG(code *c, const type *toptype, sserial ss);
	virtual void SetTrace(bool tr);
};
/// </body></classdef>

inline procedure* procedure::New(const type *t, uint arity) 
		{ procedure *r = hash.Find(t->GetSerialNo()); return r ? r : new procedure(t, arity); }
inline procedure* procedure::New(const type *t, uint arity, procthunk *thunk) 
	{ procedure *r = hash.Find(t->GetSerialNo()); if( r ) { r->SetThunk(thunk); return r; } else return new proc_builtin(t, arity, thunk); }

/* void CompileProcedures(); */

template <class T>
struct codepair { code *c; T key; T GetKey() { return key; } };

template <class T>
struct bitmappair { Bitmap *bm; T key; T GetKey() { return key; } };

} // namespace lilfes

#endif // __proc_h
